// Dialog_AddDictionary.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_ADDDICT_H
#define DIALOG_ADDDICT_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
Uint16* GetExtention( Uint16 *name ) {
	if( !name ) {  return(NULL);  }
	int dot = -1;
	for( int i = 0; i < wcslen(name); i++ ) {
		if( name[i] == L'.' ) {  dot = i;  }
	}
	if( dot == -1 ) {  return(NULL);  }
	return( name+dot );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_AddDictionary( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	static bool canload = false;
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/
			SendDlgItemMessage( hWnd, IDC_ADDDICT_FILE, WM_SETTEXT, 0, (LPARAM)L"(Click on Browse to pick a dictionary file)" );
			SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_SETTEXT, 0, (LPARAM)L"EUC-JP" );
			SendDlgItemMessage( hWnd, IDC_ADDDICT_DESC, WM_SETTEXT, 0, (LPARAM)L"(Description for the dictionary)" );

			return(TRUE);
		}// WM_INITDIALOG
		case WM_COMMAND: {
			if( thread_searching ) {  return(TRUE);  }

			WORD identifier = LOWORD(wParam);
			WORD code = HIWORD(wParam);
			switch( identifier ) {
				case IDC_ADDDICT_BROWSE: {
					//////////////////
					///   BROWSE   ///
					//////////////////
					switch( code ) {
						case BN_CLICKED: {
							/*Uint16 file[1024]; swprintf(file,L"");
							Uint16 fileTitle[1024]; swprintf(fileTitle,L"");
							OPENFILENAME openFileName;
								memset(&openFileName, 0, sizeof(openFileName));               
								openFileName.lStructSize 		 = sizeof(OPENFILENAME);
								openFileName.lpstrFilter 		 = L"All files\0*.*\0\0";
								openFileName.lpstrDefExt 		 = L"";
   							openFileName.lpstrCustomFilter = NULL;
	   						openFileName.nFilterIndex      = 0;
								openFileName.lpstrFile         = file;
								openFileName.nMaxFile			 = sizeof(file);
   							openFileName.lpstrFileTitle    = fileTitle;
								openFileName.nMaxFileTitle		 = sizeof(fileTitle);
   							openFileName.lpstrInitialDir   = NULL;
						   	openFileName.lpstrTitle        = L"Please select a dictionary to use.";
								openFileName.Flags             = OFN_NOCHANGEDIR | OFN_ENABLESIZING | OFN_FILEMUSTEXIST | OFN_EXPLORER;//*/
							char file[1024]; sprintf(file,"");
							char fileTitle[1024]; sprintf(fileTitle,"");
							OPENFILENAMEA openFileName;
								memset(&openFileName, 0, sizeof(openFileName));               
								openFileName.lStructSize 		 = sizeof(openFileName);
								openFileName.lpstrFilter 		 = "All files\0*.*\0\0";
								openFileName.lpstrDefExt 		 = "";
   							openFileName.lpstrCustomFilter = NULL;
	   						openFileName.nFilterIndex      = 0;
								openFileName.lpstrFile         = file;
								openFileName.nMaxFile			 = sizeof(file);
   							openFileName.lpstrFileTitle    = fileTitle;
								openFileName.nMaxFileTitle		 = sizeof(fileTitle);
   							openFileName.lpstrInitialDir   = NULL;
						   	openFileName.lpstrTitle        = "Please select a dictionary to use.";
								openFileName.Flags             = OFN_NOCHANGEDIR | OFN_ENABLESIZING | OFN_FILEMUSTEXIST | OFN_EXPLORER;//*/

							Log(1,L"About to open the File Open dialog box...\n");
							if( GetOpenFileNameA( &openFileName ) == TRUE ) {
							// If the dictionary was a valid file...
								Log(1,L"   File picked successfully\n");

								wstring filename = ToWString( openFileName.lpstrFile );

								// Check to see if the file has a '.' in it.
								// If it does, pop up a box to make sure that this file is
								// the one that he wants to load.
								// NOTE: EDICT files usually don't have extentions.
								bool loadfile = true;
								//Uint16 *ext = GetExtention( openFileName.lpstrFile );
								Uint16 *ext = GetExtention( (Uint16*)filename.c_str() );

								Log(1,L"File: %S\n", openFileName.lpstrFile );
								Log(1,L"Extention: %s\n",ext );

								if( ext ) {
									if( wcscmp(ext,L".jli") == 0 ) {
										MessageBox( hWnd, L"This is probably a JLookUp Index (.jli) file.  Make sure that this is really what you want.",L"Note",MB_OK );
									} else if( wcscmp(ext,L".utf") == 0 ) {
										SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_SETTEXT, 0, (LPARAM)L"UTF-8" );
									} else if( wcscmp(ext,L".dct") == 0 ) {
										SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_SETTEXT, 0, (LPARAM)L"EUC-JP" );
									} else if( wcscmp(ext,L".asc") == 0 ) {
										SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_SETTEXT, 0, (LPARAM)L"EUC-JP" );
									} else {
										Uint16 wstr[2048];
											swprintf(wstr,L"File:\n%s\n\nThis file looks like it has an extention.\nMake sure that this is what you want.", openFileName.lpstrFile );
										MessageBox( hWnd, wstr,L"Note",MB_OK );
									}
								} else {
								// The file has no extention:
									SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_SETTEXT, 0, (LPARAM)L"EUC-JP" );
								}

								SendDlgItemMessage( hWnd, IDC_ADDDICT_FILE, WM_SETTEXT, 0, (LPARAM)filename.c_str() );
								SendDlgItemMessage( hWnd, IDC_ADDDICT_DESC, WM_SETTEXT, 0, (LPARAM)filename.c_str() );

								canload = true;

								Log(1,L"Okay, we CAN LOAD the dictionary.\n");
							}// if( GetOpenFileName(...) )
							break;
						}// case BN_CLICKED
					}// switch( code )
					break;
				}// case IDC_ADDDICT_BROWSE
				case IDOK: {
					Log(1,L"IDOK\n");
					if( canload ) {
						Uint16 dict_filename[2000];
							wcsnset( dict_filename, L'\0', 2000 );
							SendDlgItemMessage( hWnd, IDC_ADDDICT_FILE, WM_GETTEXT, 2000-1,(LPARAM)dict_filename );
						Uint16 dict_encoding[2000];
							wcsnset( dict_encoding, L'\0', 2000 );
							SendDlgItemMessage( hWnd, IDC_ADDDICT_ENCODING, WM_GETTEXT, 2000-1,(LPARAM)dict_encoding );
						Uint16 dict_description[2000];
							wcsnset( dict_description, L'\0', 2000 );
							SendDlgItemMessage( hWnd, IDC_ADDDICT_DESC, WM_GETTEXT, 2000-1,(LPARAM)dict_description );

						// Set the status bar text:
						Uint16 str[2048];
							swprintf(str,L"Loading Dictionary: %s...",dict_filename );
						SetStatusBarText(str);

						// See if there is a simpler, relative path that we can use.
						// If so, use it.  If not, then use the full name.

						// This is the filename string that we'll be doing operations on.
						wstring str_filename = dict_filename;
						Log(1,L"Filename (w): %s\n", str_filename.c_str() );

						// This will be the path:
						wstring strline = L"";

						// Get the command line:
						LPTSTR cmdline = GetCommandLine();
						Log(L"   cmdline: %s\n",cmdline );
						// 'path' is the whole command line.
						strline = cmdline;
						// Go through 'path' and make it to be the path-to-JLookUp:
						int pos = strline.find(L'\"');
						if( pos >= 0 ) {
							strline = strline.substr( pos+1 );

							pos = strline.find_last_of(L'\\');
							if( pos >= 0 ) {
								strline = strline.substr( 0, pos );
							}
						}
						// Add the final slash to the path:
						strline += L"\\";
						Log(1,L"strline (w): %s\n",strline.c_str() );

						// Get up until the last slash:
						//strline = strline.substr( 0,strline.find_last_of(L'\\')+1 );
						
						// See if the dictionary is relative to the path at all:
						pos = str_filename.find( strline.c_str() );
						if( pos >= 0 ) {
							if( str_filename.size() > strline.size() ) {
								str_filename = str_filename.substr( strline.size(),-1 );
								//MessageBox( hWnd, strfile.c_str(),L"!",MB_OK );
							}
						}
						Log(1,L"   str_filename: %s\n",str_filename.c_str() );

						// Make a new dictionary:
						Dictionary_EDICT *edict_current = new Dictionary_EDICT;
							edict_current->filename = ToString( str_filename );
							edict_current->displayname = ToString( dict_description );
							edict_current->encoding = ToString( dict_encoding );
							edict_current->on = true;
							edict_current->index_entries_size = 0;
		
						// Start loading the dictionary (thread):
						HANDLE hthread = Load_Thread_EDICT_Index_Load( edict_current );
		
						// Sit around for a bit until:
						// 1) The thread finishes, or
						// 2) He presses ESCAPE.
						enum {  SEARCH_ABORT, SEARCH_DONE, SEARCH_QUIT  };
						int wtf = -1;
						MSG msg;
						while( true ) {
							if( !thread_searching ) {  wtf = SEARCH_DONE;  break;  }

							// Check to see if we have an ESCAPE key message.
							PeekMessage( &msg, NULL, 0,0, PM_REMOVE );
							TranslateMessage(&msg);
							if( msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE ) {  wtf = SEARCH_ABORT;  break;  }
							if( msg.message == WM_QUIT ) {  wtf = SEARCH_QUIT;  break;  }
							DispatchMessage(&msg);

							Sleep( 10L );
						}
						if( DestroyWindow(hwnd_searching) ) {
							hwnd_searching = NULL;
							Log(1,L"   hwnd_searching destroyed.\n");
						} else {
							Log(L"ERROR: hwnd_searching NOT destroyed.\n");
						}
						if( wtf != SEARCH_DONE ) {
						////////////////////////
						///   LOAD ABORTED   ///
						////////////////////////
							TerminateThread( hthread, 0L );
							CloseHandle(hthread);
							thread_searching = false;

							// Free up any memory that the dictionary took up.
							DeleteEDICT( edict_current );

							// Set the status bar text:
							SetStatusBarText( L"Dictionary loading... aborted." );

							if( wtf == SEARCH_QUIT ) {
								SendMessage(hwnd_mainwindow,WM_QUIT,0,0);
								return(0);
							}
						} else {
						///////////////////////////
						///   LOAD SUCCESSFUL   ///
						///////////////////////////
							CloseHandle(hthread);

							// Add the dictionary to the list:
							edict_dictionaries.push_back( edict_current );

							// Okay, now add it to the Registry:
							registry.CD(".\\Dictionaries\\EDICT");
								int reg_size = registry.GetINT("Number");
								// Make a new key:
								char reg_str[35]; sprintf(reg_str,"%i",reg_size );
								registry.NewKey(reg_str);
								registry.CD(reg_str);
									registry.SetSTRING("Path",edict_current->filename.c_str() );
									registry.SetSTRING("Name",edict_current->displayname.c_str() );
									registry.SetSTRING("Encoding",edict_current->encoding.c_str() );
									registry.SetBOOL("On",edict_current->on );
								registry.CD("..");
								registry.SetINT("Number",reg_size+1 );
			
								// Set the status bar text:
								SetStatusBarText( L"Dictionary loaded." );
						}
					}// if( canload )


					EndDialog( hWnd, IDOK );
					break;
				}// case IDOK
				case IDCANCEL: {
					EndDialog( hWnd, IDCANCEL );
					break;
            }// case IDCANCEL 
			}
			return(TRUE);
		}// case WM_COMMAND
   }
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void CreateDialog_AddDictionary( HWND hwndParent ) {
	int result = DialogBox(
		g_hinst,
		MAKEINTRESOURCE( IDD_ADDDICT ), 
		hwndParent,
		(DLGPROC)DlgProc_AddDictionary
	);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
