// Dialog_Options_EDICTCopy.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_OPTIONS_EDICTCOPY_H
#define DIALOG_OPTIONS_EDICTCOPY_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_Options_EDICTCopy( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/

			// Set the text of the Format box:
			Uint16 str[1024];
				swprintf(str,L"%S",registry.GetSTRING(".\\Results\\Copy\\Format") );
			SendDlgItemMessage( hWnd, IDC_OPTIONS_EDICTCOPY_FORMAT, WM_SETTEXT, 0, (LPARAM)str );

			// And the Separator ones:
				swprintf(str,L"%S",registry.GetSTRING(".\\Results\\Copy\\SepInfo") );
			SendDlgItemMessage( hWnd, IDC_OPTIONS_EDICTCOPY_SEPINFO, WM_SETTEXT, 0, (LPARAM)str );

				swprintf(str,L"%S",registry.GetSTRING(".\\Results\\Copy\\SepMeaning") );
			SendDlgItemMessage( hWnd, IDC_OPTIONS_EDICTCOPY_SEPMEANING, WM_SETTEXT, 0, (LPARAM)str );

				swprintf(str,L"%S",registry.GetSTRING(".\\Results\\Copy\\SepMultiple") );
			SendDlgItemMessage( hWnd, IDC_OPTIONS_EDICTCOPY_SEPMULTIPLE, WM_SETTEXT, 0, (LPARAM)str );
			
			return(TRUE);
		}
		case WM_COMMAND: {
			WORD identifier = LOWORD(wParam);
			WORD code = HIWORD(wParam);
			switch( identifier ) {
				case IDC_OPTIONS_EDICTCOPY_APPLY: {
					switch( code ) {
						case BN_CLICKED: {
							Uint16 str[1024];
							GetDlgItemText(hWnd,IDC_OPTIONS_EDICTCOPY_FORMAT,str,1024-1);
							wstring str2 = str;
							if( str2[0] != L'{' ) {  str2 = L"{" + str2;  }
							if( str2[str2.size()-1] != L'}' ) {  str2 = str2 + L"}";  }
							registry.SetSTRING(".\\Results\\Copy\\Format", ToString(str).c_str() );

							GetDlgItemText(hWnd,IDC_OPTIONS_EDICTCOPY_SEPINFO,str,1024-1);
							str2 = str;
							if( str2[0] != L'{' ) {  str2 = L"{" + str2;  }
							if( str2[str2.size()-1] != L'}' ) {  str2 = str2 + L"}";  }
							registry.SetSTRING(".\\Results\\Copy\\SepInfo", ToString(str).c_str() );

							GetDlgItemText(hWnd,IDC_OPTIONS_EDICTCOPY_SEPMEANING,str,1024-1);
							str2 = str;
							if( str2[0] != L'{' ) {  str2 = L"{" + str2;  }
							if( str2[str2.size()-1] != L'}' ) {  str2 = str2 + L"}";  }
							registry.SetSTRING(".\\Results\\Copy\\SepMeaning", ToString(str).c_str() );

							GetDlgItemText(hWnd,IDC_OPTIONS_EDICTCOPY_SEPMULTIPLE,str,1024-1);
							str2 = str;
							if( str2[0] != L'{' ) {  str2 = L"{" + str2;  }
							if( str2[str2.size()-1] != L'}' ) {  str2 = str2 + L"}";  }
							registry.SetSTRING(".\\Results\\Copy\\SepMultiple", ToString(str).c_str() );

							// This may have changed the separators:
							RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
							break;
						}//*/
					}
					break;
				}
			}//switch(identifier)//*/
			return(TRUE);
		}
   }
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateDialog_Options_EDICTCopy( HWND hwndParent ) {
	HWND hwnd = CreateDialog(
		g_hinst,
		MAKEINTRESOURCE( IDD_OPTIONS_EDICTCOPY ), 
		hwndParent,
		(DLGPROC)DlgProc_Options_EDICTCopy
	);
	return( hwnd );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
