// Dialog_Options_RadicalLookup.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_OPTIONS_RADICALLOOKUP_H
#define DIALOG_OPTIONS_RADICALLOOKUP_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_Options_RadicalLookup( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/

			// Check the indexing button:
			if( registry.GetBOOL(".\\RadicalLookup\\CtrlClick") ) {
				SendDlgItemMessage( hWnd, IDC_RADICAL_CTRLCLICK, BM_SETCHECK, BST_CHECKED, 0 );
			}
			
			return(TRUE);
		}
		case WM_COMMAND: {
			WORD identifier = LOWORD(wParam);
			WORD code = HIWORD(wParam);
			switch( identifier ) {
				case IDC_RADICAL_CTRLCLICK: {
					switch( code ) {
						case BN_CLICKED: {
							if( IsDlgButtonChecked( hWnd, identifier ) ) {
								registry.SetBOOL(".\\RadicalLookup\\CtrlClick", true );
							} else {
								registry.SetBOOL(".\\RadicalLookup\\CtrlClick", false );
							}
							break;
						}
					}
					break;
				}
			}//switch(identifier)
			return(TRUE);
		}
   }
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateDialog_Options_RadicalLookup( HWND hwndParent ) {
	HWND hwnd = CreateDialog(
		g_hinst,
		MAKEINTRESOURCE( IDD_OPTIONS_RADICAL ), 
		hwndParent,
		(DLGPROC)DlgProc_Options_RadicalLookup
	);
	return( hwnd );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
