// Dialog_ResultHeader.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_RESULTHEADER_H
#define DIALOG_RESULTHEADER_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_ResultHeader( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/
			for( int i = 0; i < HDR_RESULT_MAX; i++ ) {
				int mod = result_header_items[i].hwnd;
				if( mod == -1 ) {
					mod = 2;
				}
				SendDlgItemMessage( hWnd, IDC_RADIO1+(i*3)+mod, BM_SETCHECK, BST_CHECKED, 0 );
			}

			return(TRUE);
		}
		case WM_COMMAND: {
			WORD identifier = LOWORD(wParam);
			WORD code = HIWORD(wParam);
			switch( identifier ) {
				case IDOK: {
					EndDialog( hWnd, IDOK );
					break;
				}
				case IDCANCEL: {
					EndDialog( hWnd, IDCANCEL );
					break;
            }
				default: {
					if( identifier >= IDC_RADIO1 && identifier <= IDC_RADIO18 ) {
						Log(L"C L I C K ! !\n");

						// Figure out what item and everything it applies to:
						int index = (identifier - IDC_RADIO1) / 3;
						int mod = identifier - (IDC_RADIO1 + index*3);

						result_header_items[index].hwnd = mod;
						if( mod == 2 ) {
							result_header_items[index].hwnd = -1;
						}
						
						SetResultHeaders( hwnd_resultwindow );
						RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
					}
				}
			}
			return(TRUE);
		}
   }
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
int CreateDialog_ResultHeader( HWND hwndParent ) {
	int result = DialogBox(
		g_hinst,
		MAKEINTRESOURCE( IDD_RESULTHEADER ), 
		hwndParent,
		(DLGPROC)DlgProc_ResultHeader
	);
	return( result );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
