// Dictionary_EDICT.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DICTIONARY_EDICT_H
#define DICTIONARY_EDICT_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
struct EDICT_Index_Entry {
	Uint16 *word;
	Uint16 *kana;
	long fileloc;
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// Here's the structure for a dictionary:
struct Dictionary_EDICT {
	string filename; // The dictionary's filename.
	string displayname; // The pretty name to show.
	string encoding; // What encoding it's in.
	EDICT_Index_Entry *index_entries;
		int index_entries_size;
	bool on; // If we're using it for searching.
};
///////////////////////////////////////////////////////////
vector<Dictionary_EDICT*> edict_dictionaries;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
const int DM_DSTART =	 100;
const int DM_DSTOP =		 150;
const int DM_ALL =		1100;
const int DM_NONE =		1200;
const int DM_DONE =		1300;
HMENU hmenu_dictionaries;
HMENU CreateDictionaryMenu( HWND hwndParent ) {
	//static HBITMAP hbmpChecked = LoadBitmap(g_hinst,MAKEINTRESOURCE(IDB_BITMAP2));

	HMENU hMenu = CreatePopupMenu();

	AppendMenu( hMenu, MF_STRING|MF_DISABLED, 0, L"Right-click the dictionaries to use." );
     	AppendMenu( hMenu, MF_SEPARATOR, NULL,NULL );  
	for( int d = 0; d < edict_dictionaries.size(); d++ ) {
		Uint16 str[1024];
			swprintf(str,L"%S",edict_dictionaries[d]->displayname.c_str() );
		AppendMenu( hMenu, MF_STRING|MF_DISABLED, DM_DSTART+d, str );
		//SetMenuItemBitmaps( hMenu, DM_DSTART+d, MF_BYCOMMAND, NULL, hbmpChecked );
		if( edict_dictionaries[d]->on ) {
			CheckMenuItem( hMenu, DM_DSTART+d, MF_BYCOMMAND|MF_CHECKED );
		}
	}
		AppendMenu( hMenu, MF_SEPARATOR, NULL,NULL );
	AppendMenu( hMenu, MF_STRING|MF_DISABLED, DM_ALL, L"(All)" );
	AppendMenu( hMenu, MF_STRING|MF_DISABLED, DM_NONE, L"(None)" );
		AppendMenu( hMenu, MF_SEPARATOR, NULL,NULL );
	AppendMenu( hMenu, MF_STRING, DM_DONE, L"-done-" );

	return( hMenu );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
/*    This frees up the memory that a Dictionary_EDICT*
   took up. */
void DeleteEDICT( Dictionary_EDICT *dictionary ) {
	// Go through every entry in the dictionary:
	for( int i = 0; i < dictionary->index_entries_size; i++ ) {
		// If there's a word, delete it:
		if( dictionary->index_entries[i].word ) {
			delete [] dictionary->index_entries[i].word;
		}
		// If there's kana, delete it:
		if( dictionary->index_entries[i].kana ) {
			delete [] dictionary->index_entries[i].kana;
		}
	}
	// Now, get rid of the array:
	delete [] dictionary->index_entries;
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
