// Edict_Copy.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef EDICT_COPY_H
#define EDICT_COPY_H
///////////////////////////////////////////////////////////
// For the copy function:
#include "CopyPaste.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
wstring Edict_GetMeaning( EDICT_Entry &entry ) {
	wstring meaning = L"";
	for( int m = 0; m < entry.meaning.size(); m++ ) {
		meaning += entry.meaning[m];
		if( m < entry.meaning.size()-1 ) {
			//meaning += L" | ";

			// NEW: Do it by using the desired format:
			string str = registry.GetSTRING(".\\Results\\Copy\\SepMeaning");
			// Take out the {}s:
			str = str.substr( 1,str.size()-2 );
			meaning += ToWString( str );
		}
	}
	return(meaning);
}
///////////////////////////////////////////////////////////
wstring Edict_GetInfo( EDICT_Entry &entry ) {
	wstring info = L"";
	for( int m = 0; m < entry.info.size(); m++ ) {
		info += entry.info[m];
		if( m < entry.info.size()-1 ) {
			// NEW: Do it by using the desired format:
			string str = registry.GetSTRING(".\\Results\\Copy\\SepInfo");
			// Take out the {}s:
			str = str.substr( 1,str.size()-2 );
			info += ToWString( str );
		}
	}
	return(info);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
enum {
	EINFO_WORD,
	EINFO_KANA,
	EINFO_MEANING,
	EINFO_ALL
};
///////////////////////////////////////////////////////////
void CopySelectedEdictInfo( int what ) {
	// This is what we're going to end up with:
	wstring text_to_copy = L"";

	// Now, go through all of the entries:
	for( int e = 0; e < edict_results.size(); e++ ) {
		EDICT_Entry *entry = &edict_results[e];
		if( !entry->selected ) {  continue;  }

		// If this is NOT the first entry being copied, we need to
		// add something to separate the entries.
		if( text_to_copy.size() > 0 ) {
			wstring str = ToWString( registry.GetSTRING(".\\Results\\Copy\\SepMultiple") );
			// Strip the {}s:
			str = str.substr( 1, str.size()-2 );
			// Convert that to meaninful text:
			while( true ) {
				int pos = str.find(L"\\n");
				if( pos >= 0 ) {  str.replace( pos,2, L"\n" );  continue;  }
				pos = str.find(L"\\t");
				if( pos >= 0 ) {  str.replace( pos,2, L"\t" );  continue;  }
				pos = str.find(L"\\:");
				if( pos >= 0 ) {  str.replace( pos,2, L":" );  continue;  }
				break;
			}
			// Add it to the copy text:
			text_to_copy += str;
		}

		// Get the meaningful text from this entry:
		wstring copystr = L"";
		if( what == EINFO_WORD ) {
			copystr = entry->word;
		} else if( what == EINFO_KANA ) {
			copystr = entry->kana;
		} else if( what == EINFO_MEANING ) {
			copystr = Edict_GetMeaning( *entry );
		} else if( what == EINFO_ALL ) {
			// NEW:
			// Get the format:
			copystr = ToWString( registry.GetSTRING(".\\Results\\Copy\\Format") );
			// Strip the {}s:
			copystr = copystr.substr( 1, copystr.size()-2 );

			wstring info = Edict_GetInfo( *entry );
			wstring meaning = Edict_GetMeaning( *entry );

			while( true ) {
				int pos = copystr.find(L"\\n");
				if( pos >= 0 ) {  copystr.replace( pos,2, L"\n" );  continue;  }
				pos = copystr.find(L"\\t");
				if( pos >= 0 ) {  copystr.replace( pos,2, L"\t" );  continue;  }
				pos = copystr.find(L"\\:");
				if( pos >= 0 ) {  copystr.replace( pos,2, L":" );  continue;  }

				pos = copystr.find(L"%word");
				if( pos >= 0 ) {  copystr.replace( pos,5, entry->word.c_str() );  continue;  }
				pos = copystr.find(L"%kana");
				if( pos >= 0 ) {  copystr.replace( pos,5, entry->kana.c_str() );  continue;  }
				pos = copystr.find(L"%info");
				if( pos >= 0 ) {  copystr.replace( pos,5, info.c_str() );  continue;  }
				pos = copystr.find(L"%meaning");
				if( pos >= 0 ) {  copystr.replace( pos,8, meaning.c_str() );  continue;  }
				break;
			}// while(true)
		}

		text_to_copy += copystr;
	}// for(e)

	// Copy the text in the specified format:
	CopyTextUsingComboboxEncoding( text_to_copy );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
