// JLookUp.cpp | by Doug Manley
///////////////////////////////////////////////////////////
//
//////////////////////////////////////////////
///   #defines for internal program use:   ///
//////////////////////////////////////////////
//
/* This allows the program to print to out.conversion.txt,
	printing out its progress in converting a ROMAji string to
	a kana one. */
//#define DEBUG_CONVERSION
//
/* This is for different versions of JLookUp. */
//#define VERSION_NT
// NOTE: this is defined by the project settings now.
//
/* This is for taking stuff OUT in UBER debugging. */
//#define UBERDEBUG
/* This is for not drawing text. */
//#define NOTEXT
//
///////////////////////////////////////////////////////////
// We're going to be using Uint16s for text:
#define UNICODE
#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;

#include <Commctrl.h>

#include <RichEdit.h>

#include <stdio.h>

#include <stdlib.h>
#include <string>
#include <vector>
using namespace std;
///////////////////////////////////////////////////////////
// Windows SDK data:
const int WM_MOUSEWHEEL = 0x020A;
const int WHEEL_DELTA = 120; // Value for rolling one dete
///////////////////////////////////////////////////////////
// Typedefs:
typedef unsigned char Uint8;
typedef unsigned short Uint16;
typedef unsigned long int Uint32;
///////////////////////////////////////////////////////////
// Version information:
#ifdef VERSION_NT
Uint16 version_info[32] = L"1.0.7.5d (NT)";
Uint16 version_type[] = L"NT";
#else
Uint16 version_info[32] = L"1.0.7.5d";
Uint16 version_type[] = L"98";
#endif
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// For the Log() functions:
#include "Log.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// Wide-string comparison with wildcards:
#include "xwcscmp.h"

/*		This is the string-matching function that we use.
	It calls RB_Match().
	   Here, the FIRST parameter is the normal text, and the
	SECOND parameter is the one with the wildcards.
*/
bool StringsMatch( wstring &text, wstring &text_wildcards ) {
	return( RB_Match( (Uint16*)text.c_str(), (Uint16*)text_wildcards.c_str() ) == TRUE );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// The project's resource information:
#include "resource.h"

// Virtual Key definitions:
#include "VK.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// The HINSTANCE of the program:
HINSTANCE g_hinst;

// Cursors:
HCURSOR cursor_arrow,
		  cursor_resize_horizontal,
		  cursor_resize_vertical,
		  cursor_hand;

// Bitmaps:
HBITMAP bitmap_sort_asc1,
		  bitmap_sort_asc2,
		  bitmap_sort_dsc1,
		  bitmap_sort_dsc2;
///////////////////////////////////////////////////////////
// The Miscellenous font:
HFONT hfont_msgothic12;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
enum {
	SEARCH_STYLE_START,
	SEARCH_STYLE_MIDDLE,
	SEARCH_STYLE_END,
	SEARCH_STYLE_WHOLE,
};
int search_style_location = SEARCH_STYLE_START;

// Match multiple substrings:
int search_matchsubstrings = 0;

// Force using word instead of kana.
int search_forcewordsearch = 0;

enum {
	SEARCH_CONVERSION_ROMAJI_NONE = 0,
	SEARCH_CONVERSION_ROMAJI_TOKANA = 1,
};
int search_conversion_romaji = SEARCH_CONVERSION_ROMAJI_NONE;

enum {
	SEARCH_CONVERSION_KANA_SENSITIVE = 0,
	SEARCH_CONVERSION_KANA_INSENSITIVE = 1,
};
int search_conversion_kana = SEARCH_CONVERSION_KANA_SENSITIVE;

// Show the processed input:
int search_conversion_show = 0;

int search_results_max = 200;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// The Main Window:
HWND hwnd_mainwindow = NULL;
	// Subwindows of the Main Window:

	// The Status Window:
	HWND hwnd_main_status = NULL;

	// The Search Window:
	HWND hwnd_searchwindow = NULL;
		// SubWindows of the Search Window:
		HWND hwnd_searchrebar;
			const int WID_SEARCH_REBAR = 1032;
			HWND hwnd_searchrebar_toolbar_lang = NULL;
			HWND hwnd_searchrebar_toolbar_location = NULL;
			HWND hwnd_searchrebar_toolbar_strings = NULL;
			HWND hwnd_searchrebar_toolbar_conversion = NULL;
			HWND hwnd_searchrebar_combobox_encode = NULL;
				const int WID_SEARCH_COMBOBOX = 1101;
			HWND hwnd_searchrebar_toolbar_encodego = NULL;
			HWND hwnd_searchrebar_edit_resultsize = NULL;
				const int WID_SEARCH_RESULTSMAX = 1103;

		HWND hwnd_searchedit = NULL;
			const int WID_SEARCH_EDIT = 1111;

	// The Kanji Window:
	HWND hwnd_kanjiwindow = NULL;
		// Subwindows of the Kanji Window:
		HWND hwnd_kanjilist1 = NULL;
			const int WID_KANJI_LIST1 = 1211;
		HWND hwnd_kanjilist2 = NULL;
			const int WID_KANJI_LIST2 = 1221;

	// The Result Window:
	HWND hwnd_resultwindow;
		// Subwindows of the Result Window:
		HWND hwnd_resultlist[2] = { NULL, NULL };
			const int WID_RESULT_LIST1 = 1311;
			const int WID_RESULT_LIST2 = 1321;

	// The Radical Lookup Window:
	HWND hwnd_radicallookup = NULL;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
/*    This returns the maximum number of results that we are
   allowing for a search.
*/
int GetMaxResults() {
	// This will store the string:
	Uint16 strresults[100];
		wcsnset( strresults, L'\0', 100 );
	// Get the text of the result-size:
	SendMessage( hwnd_searchrebar_edit_resultsize,WM_GETTEXT,99,(LPARAM)strresults );
	// Convert it to an integer:
	int max = _wtoi( strresults );
	// Return that sucker:
	return(max);
}
///////////////////////////////////////////////////////////
// For converting strings to wstrings and vice-versa:
#include "ToString.h"
///////////////////////////////////////////////////////////
/* Set the Main Window's status bar's text. */
void SetStatusBarText( int index, wstring str ) {
	SendMessage( hwnd_main_status, SB_SETTEXT, index, (LPARAM)(Uint16*)str.c_str() );
}
void SetStatusBarText( wstring str ) {
	SetStatusBarText( 0, str );
}
///////////////////////////////////////////////////////////
// For the About Window:
#include "Window_About.h"

// For the program options:
#include "Registry.h"
Registry registry;

// This makes the default options file:
#include "MakeNewOptionsFile.h"

// Helpful Header functions:
#include "Header.h"

// Character conversion:
#include "JISToUNI2.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#include "Dictionary_EDICT.h"

#include "Edict.h"
#include "Kanjidic.h"
#include "Edict_English.h"

#include "FuzzySearch.h"
///////////////////////////////////////////////////////////
// The currently selected kanji:
int kanji_selected = -1;

// Result Window:
// *Selecting Multiple Entries*
// The BASE is the last thing that was CTRL-clicked.
int result_base = -1;
// The LAST is the last thing that was clicked at all.
int result_last = -1;
///////////////////////////////////////////////////////////
// For the thread functions:
#include "Threads.h"
///////////////////////////////////////////////////////////
bool search_lock = false;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#include "Conversion.h"
#include "Search.h"

#include "Edict_Sort.h"
#include "Search_Dict.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#include "Search_Toolbar.h"
#include "Result_Window.h"
#include "Kanji_Window.h"
#include "RadicalLookup_Window.h"
#include "Search_Window.h"

#include "Main_Window.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#ifndef JCONSOLE
INT WINAPI WinMain( HINSTANCE hInstance, HINSTANCE, PSTR, INT iCmdShow ) {
#else
int main( int argc, char *argv[] ) {
	HINSTANCE hInstance;
#endif
	///////////////////////////////
	///   GLOBAL OUTPUT FILES   ///
	///////////////////////////////
	Log_Open();
	Log(L"********************"); for( int e = 0; e < wcslen(version_info); e++ ) {  Log(L"*");  }  Log(L"\n");
	Log(L"***   JLookUp %s   ***\n",version_info );
	Log(L"********************"); for( e = 0; e < wcslen(version_info); e++ ) {  Log(L"*");  }  Log(L"\n");
	Log(L"   (Unicode output file)\n");

	///////////////////////
	///   DEBUG LEVEL   ///
	///////////////////////
	debug_level = 0;
	FILE *fdebug = fopen("debug_level.dat","rb");
	if( fdebug ) {
		fscanf(fdebug,"%i",&debug_level);
		fclose(fdebug);
	} else {
		Log(L"WARNING: Could not open 'debug_level.dat'.\n");
	}

	Log(1,L"*************************************\n");
	Log(1,L"***   L E V E L  1    D E B U G   ***\n");
	Log(1,L"*************************************\n");
	Log(1,L"   (Adds LOTS of print statements)\n");

#ifdef UBERDEBUG
	Log(L"********************************\n");
	Log(L"***   U B E R    D E B U G   ***\n");
	Log(L"********************************\n");
	Log(L"   (Takes away a LOT of features)\n");
#endif



	/////////////////////////////
	///   LOAD THE REGISTRY   ///
	/////////////////////////////
	Log(L"Loading Options...............");
	bool loaded = registry.LoadFromFile( "Options.jlreg" );
	if( !loaded ) {
		Log(L"FAILED\n");
		Log(L"   Creating and using default options file...\n");
		Log(L"Loading Options...");
		MakeNewOptionsFile("Options.jlreg");
		loaded = registry.LoadFromFile("Options.jlreg");
		if( loaded ) {  Log(L"OKAY\n");  }
		else {  Log(L"FAILED\n");  }
	} else {  Log(L"OKAY\n");  }
	registry.CD( "." );

	Log(1,L"Here's JLookUp's registry:\n");
	if( debug_level > 0 ) {
		registry.Print();
	}
	Log(1,L"(End of registry).\n");

	// If this version is NEWER than the options file,
	// we need to update the options file:
	if( !registry.ItemExists(".\\Misc\\Version") || ToString(version_info) > string(registry.GetSTRING(".\\Misc\\Version")) ) {
		Log(L"************************\n");
		Log(L"***   OPTIONS FILE   ***\n");
		Log(L"************************\n");
		//
		// 1) Make a new options file.
		//
		char *filename = "temp_optionsfile_temp";
		if( MakeNewOptionsFile(filename) ) {
			Log(L"   %S made okay.\n",filename );
		//
		// 2) Load it into new registry.
		//
			Registry newreg;
				newreg.LoadFromFile(filename);
		//
		// 3) Copy the new one ONTO the old one (if it has something that the old one doesn't).
		//
			registry.MergeFrom( newreg );
		//
		// 4) Delete the new options file.
		//
			if( remove(filename) == 0 ) {
				Log(L"   %S removed sucessfully.\n",filename);
			} else {
				Log(L"   ERROR: could not remove %S\n",filename );
			}
			// Update the version, now:
			registry.SetSTRING(".\\Misc\\Version",ToString(version_info).c_str() );

			// Make sure that all dictionaries have encodings:
			registry.CD(".\\Dictionaries\\EDICT");
			int reg_size = registry.GetINT("Number");
			for( int i = 0; i < reg_size; i++ ) {
				char reg_str[35]; sprintf(reg_str,"%i",i );
				registry.CD(reg_str);
				if( !registry.ItemExists("Encoding") ) {
					registry.SetSTRING("Encoding", "EUC-JP" );
				}
				registry.CD("..");
			}
		} else {
			Log(L"   ERROR: Couldn't make the new options file (%S).\n",filename);
		}
	}


#ifdef JCONSOLE
	Thread_LoadAllEDICTS( NULL );
	search_conversion_romaji = SEARCH_CONVERSION_ROMAJI_TOKANA;
	search_style_location = SEARCH_STYLE_WHOLE;

	printf("Welcome to the JLookUp console.  I must be desperate.\n");
	char buffer[1024];
	while( true ) {
		printf("> ");
			// Clear the buffer.
			strnset( buffer, '\0', 1024 );
		gets( buffer );

		// Get rid of the end-line character:
		if( strlen(buffer) > 0 && (buffer[strlen(buffer)-1] == '\r' || buffer[strlen(buffer)-1] == '\n') ) {
			buffer[strlen(buffer)-1] = '\0';
		}

		if( strlen(buffer) == 0 ) {
			break;
		}

		printf("   <<%s>>\n",buffer);

		wstring searchtext = ToWString( string(buffer) );

		// Thread search time!
		THREAD_SEARCH ts;
			ts.search_text = &searchtext;
			ts.mode = TS_NORMAL;
		// Start searching (thread):
		//HANDLE hthread = Load_Thread_Search( &ts );
		Thread_Search( &ts );

		/*
		edict_results.clear();
		Edict_SearchFor( ToWString( string(buffer) ) );
		SortResults();//*/

		if( edict_results.size() == 0 ) {
			printf("Sorry, there are no results.\n");
		} else {
			printf("There are %i results.\n", edict_results.size() );
			for( int i = 0; i < edict_results.size(); i++ ) {
				printf("1) %s\n", ToString( Edict_GetMeaning( edict_results[i] ) ).c_str() );
			}
		}
	}
	return(0);
#endif



	////////////////////////////////////
	///   Set the global HINSTANCE   ///
	////////////////////////////////////
	g_hinst = hInstance;
   
	////////////////////////////
   ///    Initialize GDI+   ///
	////////////////////////////
	Log(L"Intializing GDI+..............");
		GdiplusStartupInput gdiplusStartupInput;
		ULONG_PTR gdiplusToken;
   int status = GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	if( status == Ok ) {  Log(L"OKAY\n");  }
	else {  Log(L"FAILED\n");  exit(0);  }

	/////////////////////////////////////////////////////////
	///   Ensure that the common control DLL is loaded.   ///
	/////////////////////////////////////////////////////////
	Log(L"Intializing Common Controls...");
	INITCOMMONCONTROLSEX icex;
		icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icex.dwICC  = ICC_BAR_CLASSES | ICC_COOL_CLASSES | ICC_LISTVIEW_CLASSES;
	BOOL init = InitCommonControlsEx(&icex);
	if( init ) {  Log(L"OKAY\n");  }
	else {  Log(L"FAILED\n");  exit(0);  }


	//////////////////////////////
	///    Load the cursors:   ///
	//////////////////////////////
	Log(L"Loading cursors...............");
	if( debug_level > 0 ) {  Log(L"\n");  }
	cursor_arrow = LoadCursor( NULL,IDC_ARROW );
		Log(1,L"   cursor_arrow: %s\n",cursor_arrow?L"OKAY":L"FAILED" );
	cursor_resize_horizontal = LoadCursor( NULL,IDC_SIZEWE );
		Log(1,L"   cursor_resize_horizontal: %s\n",cursor_resize_horizontal?L"OKAY":L"FAILED" );
	cursor_resize_vertical = LoadCursor( NULL,IDC_SIZENS );
		Log(1,L"   cursor_resize_vertical: %s\n",cursor_resize_vertical?L"OKAY":L"FAILED" );
	cursor_hand = LoadCursor( NULL,IDC_HAND );
		Log(1,L"   cursor_hand: %s\n",cursor_hand?L"OKAY":L"FAILED" );
	if( debug_level == 0 ) {
		if( cursor_arrow && cursor_resize_horizontal && cursor_resize_vertical && cursor_hand ) {
			Log(L"OKAY\n");
		} else {
			Log(L"FAILED\n");
		}
	}

	/////////////////////////////
	///   Load the bitmaps:   ///
	/////////////////////////////
	Log(L"Loading bitmaps...............");
	if( debug_level > 0 ) {  Log(L"\n");  }
	bitmap_sort_asc1 = LoadBitmap( g_hinst, MAKEINTRESOURCE( IDB_HEADER_SORT_ASC1 ) );
	Log(1,L"   bitmap_sort_asc1: %s\n",bitmap_sort_asc1?L"OKAY":L"FAILED" );
	bitmap_sort_asc2 = LoadBitmap( g_hinst, MAKEINTRESOURCE( IDB_HEADER_SORT_ASC2 ) );
	Log(1,L"   bitmap_sort_asc2: %s\n",bitmap_sort_asc2?L"OKAY":L"FAILED" );
	bitmap_sort_dsc1 = LoadBitmap( g_hinst, MAKEINTRESOURCE( IDB_HEADER_SORT_DSC1 ) );
	Log(1,L"   bitmap_sort_dsc1: %s\n",bitmap_sort_dsc1?L"OKAY":L"FAILED" );
	bitmap_sort_dsc2 = LoadBitmap( g_hinst, MAKEINTRESOURCE( IDB_HEADER_SORT_DSC2 ) );
	Log(1,L"   bitmap_sort_dsc2: %s\n",bitmap_sort_dsc2?L"OKAY":L"FAILED" );
	if( debug_level == 0 ) {
		if( bitmap_sort_asc1 && bitmap_sort_asc2 && bitmap_sort_dsc1 && bitmap_sort_dsc2 ) {
			Log(L"OKAY\n");
		} else {
			Log(L"FAILED\n");
		}
	}


	////////////////////////////////////
	///   FUZZY SEARCH INFORMATION   ///
	////////////////////////////////////
	// Load the fuzzy search file:
	Log(L"Loading Fuzzy Search Data.....");
	if( debug_level > 0 ) {  Log(L"\n");  }
	if( LoadFuzzySearchInfo() ) {
		Log(L"OKAY\n");
	} else {
		Log(L"FAILED\n");
	}

	

	/////////////////////////
	///   RESULT WINDOW   ///
	/////////////////////////
	// Fonts:
	Log(L"Loading Result Window Fonts...");
	if( debug_level > 0 ) {  Log(L"\n");  }
		hfont_result_word = CreateFont(
			-MulDiv( registry.GetINT(".\\Results\\Fonts\\Word\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Results\\Fonts\\Word\\Font") ).c_str()
		);
		Log(1,L"   hfont_result_word: %s\n",hfont_result_word?L"OKAY":L"FAILED" );
		hfont_result_kana = CreateFont(
			-MulDiv( registry.GetINT(".\\Results\\Fonts\\Kana\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Results\\Fonts\\Kana\\Font") ).c_str()
		);
		Log(1,L"   hfont_result_kana: %s\n",hfont_result_kana?L"OKAY":L"FAILED" );
		hfont_result_meaning = CreateFont(
			-MulDiv( registry.GetINT(".\\Results\\Fonts\\Meaning\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Results\\Fonts\\Meaning\\Font") ).c_str()
		);
		Log(1,L"   hfont_result_meaning: %s\n",hfont_result_meaning?L"OKAY":L"FAILED" );
		hfont_result_info = CreateFont(
			-MulDiv( registry.GetINT(".\\Results\\Fonts\\Info\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Results\\Fonts\\Info\\Font") ).c_str()
		);
		Log(1,L"   hfont_result_info: %s\n",hfont_result_info?L"OKAY":L"FAILED" );
	if( debug_level == 0 ) {
		if( hfont_result_word && hfont_result_kana && hfont_result_meaning && hfont_result_info ) {
			Log(L"OKAY\n");
		} else {
			Log(L"FAILED\n");
		}
	}

	// Colors:
	Log(L"Loading Result Window Colors..");
		color_result_word.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Fonts\\Word\\Color") );
		color_result_kana.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Fonts\\Kana\\Color") );
		color_result_meaning.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Fonts\\Meaning\\Color") );
		color_result_info.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Fonts\\Info\\Color") );

		color_result_bg1.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Colors\\BG1") );
		color_result_bg2.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Colors\\BG2") );
		color_result_border_inside.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Colors\\Border_Inside") );
		color_result_border_outside.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Colors\\Border_Outside") );
		color_result_windowbg.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Results\\Colors\\BGWindow") );
	Log(L"OKAY\n");

	////////////////////////
	///   KANJI WINDOW   ///
	////////////////////////
	// Fonts:
	Log(L"Loading Kanji Window Fonts....");
	if( debug_level > 0 ) {  Log(L"\n");  }
		hfont_kanji_kanji = CreateFont(
			-MulDiv( registry.GetINT(".\\Kanji\\Fonts\\Kanji\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Kanji\\Font") ).c_str()
		);
		Log(1,L"   hfont_kanji_kanji: %s\n",hfont_kanji_kanji?L"OKAY":L"FAILED" );
		hfont_kanji_onkun = CreateFont(
			-MulDiv( registry.GetINT(".\\Kanji\\Fonts\\On\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\On\\Font") ).c_str()
		);
		Log(1,L"   hfont_kanji_onkun: %s\n",hfont_kanji_onkun?L"OKAY":L"FAILED" );
		hfont_kanji_meaning = CreateFont(
			-MulDiv( registry.GetINT(".\\Kanji\\Fonts\\Meaning\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Meaning\\Font") ).c_str()
		);
		Log(1,L"   hfont_kanji_meaning: %s\n",hfont_kanji_meaning?L"OKAY":L"FAILED" );
	if( debug_level == 0 ) {
		if( hfont_kanji_kanji && hfont_kanji_onkun && hfont_kanji_meaning ) {
			Log(L"OKAY\n");
		} else {
			Log(L"FAILED\n");
		}
	}

	// Colors:
	Log(L"Loading Kanji Window Colors...");
		color_kanji.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Fonts\\Kanji\\Color") );
		color_kanji_on.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Fonts\\On\\Color") );
		color_kanji_kun.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Fonts\\Kun\\Color") );
		color_kanji_meaning.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Fonts\\Meaning\\Color") );

		color_kanji_bg1.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Colors\\BG1") );
		color_kanji_bg2.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Colors\\BG2") );
		color_kanji_border_inside.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Colors\\Border_Inside") );
		color_kanji_border_outside.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Colors\\Border_Outside") );
		color_kanji_windowbg.SetFromCOLORREF( (COLORREF)registry.GetINT(".\\Kanji\\Colors\\BGWindow") );
	Log(L"OKAY\n");

	////////////////
	///   MISC   ///
	////////////////
	// Font:
	Log(L"Loading miscellaneous fonts...");
	if( debug_level > 0 ) {  Log(L"\n");  }
		hfont_msgothic12 = CreateFont(
			-MulDiv( registry.GetINT(".\\Misc\\Font\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72),
			0,0,0,0,0,0,0,0,0,0,0,0,
			ToWString( registry.GetSTRING(".\\Misc\\Font\\Font") ).c_str()
		);
		Log(1,L"   hfont_msgothic12: %s\n",hfont_msgothic12?L"OKAY":L"FAILED" );
	if( debug_level == 0 ) {
		if( hfont_msgothic12 ) {
			Log(L"OKAY\n");
		} else {
			Log(L"FAILED\n");
		}
	}


	//////////////////////////////////
	///   CREATE THE MAIN WINDOW   ///
	//////////////////////////////////
	int x = CW_USEDEFAULT, y = CW_USEDEFAULT, w = 800, h = 600;
	if( registry.GetBOOL(".\\Window\\RememberSize") ) {
		registry.CD(".\\Window");
		x = registry.GetINT("Window_x");
		y = registry.GetINT("Window_y");
		w = registry.GetINT("Window_w");
		h = registry.GetINT("Window_h");
		if( w < 30 || h < 30 || x < -300 || x > 3000 || y < -300 || y > 3000 ) {
			x = CW_USEDEFAULT; y = CW_USEDEFAULT; w = 800; h = 600;
			Log(L"The window position settings were incorrect--They have been restored to the defaults.");
			MessageBox(NULL,L"The window position settings were incorrect.\n\nThey have been restored to the defaults.",L"Warning:",MB_OK );
		}
	}
	Log(L"Creating main window:");
	hwnd_mainwindow = CreateMain_Window( NULL, x,y, w,h );
	if( !hwnd_mainwindow ) {
		Log(L"ERROR: hwnd_mainwindow == NULL\n");
		MessageBox(NULL,L"Could not create main window!",L"ERROR",MB_OK );
		exit(-1);
	} else {
		Log(L"Main window created okay.\n");
	}


	/////////////////////////////
	///   CHECK THE BUTTONS   ///
	/////////////////////////////
	// Check the buttons:
	if( registry.GetBOOL(".\\Misc\\AlwaysOnTop") ) {
		registry.SetBOOL(".\\Misc\\AlwaysOnTop", false );
		SendMessage( hwnd_mainwindow, WM_COMMAND, MAKEWPARAM(ID_OPTIONS_ALWAYSONTOP,0), 0 );
	}
	{
		// For the Language-type:
		{
			int type = registry.GetINT(".\\Search\\Language");
			if( type != ID_LANG_JP && type != ID_LANG_EN && type != ID_LANG_X ) {
				Log(L"WARNING: The language type is invalid; setting it to default.\n");
				type = ID_LANG_X;
				registry.SetINT(".\\Search\\Language",type);
			}
			SendMessage( hwnd_searchrebar_toolbar_lang, TB_CHECKBUTTON, type, TRUE );
		}

		// For the Search-type:
		{
			// The button that's down is 'search_style_location'.
			int type = registry.GetINT(".\\Search\\Toolbars\\Type" );
			switch( type ) {
				case SEARCH_STYLE_START: {		type = ID_SEARCH_START;		break;  }
				case SEARCH_STYLE_MIDDLE: {	type = ID_SEARCH_MIDDLE;	break;  }
				case SEARCH_STYLE_END: {		type = ID_SEARCH_END;		break;  }
				case SEARCH_STYLE_WHOLE: {		type = ID_SEARCH_WHOLE;		break;  }
			}
			SendMessage( hwnd_searchrebar_toolbar_location, TB_CHECKBUTTON, type, TRUE );
			SendMessage( hwnd_searchwindow, WM_COMMAND, type, NULL );
		}
		// For the match-substrings:
		if( registry.GetBOOL(".\\Search\\Toolbars\\Substr") ) {
			SendMessage( hwnd_searchrebar_toolbar_strings, TB_CHECKBUTTON, ID_MATCHSUBSTRINGS, TRUE );
			SendMessage( hwnd_searchrebar_toolbar_strings, WM_COMMAND, ID_MATCHSUBSTRINGS, NULL );
		}
		// For the search-only-word
		if( registry.GetBOOL(".\\Search\\Toolbars\\Word") ) {
			SendMessage( hwnd_searchrebar_toolbar_strings, TB_CHECKBUTTON, ID_FORCEWORDSEARCH, TRUE );
			SendMessage( hwnd_searchrebar_toolbar_strings, WM_COMMAND, ID_FORCEWORDSEARCH, NULL );
		}
		// For fuzzy-search:
		if( registry.GetBOOL(".\\Search\\Toolbars\\Fuzzy") ) {
			SendMessage( hwnd_searchrebar_toolbar_strings, TB_CHECKBUTTON, ID_FUZZY, TRUE );
			registry.SetBOOL(".\\Search\\Toolbars\\Fuzzy",false);
			SendMessage( hwnd_searchrebar_toolbar_strings, WM_COMMAND, ID_FUZZY, NULL );
		}
		// For ROMAji conversion:
		if( registry.GetBOOL(".\\Search\\Toolbars\\Romaji-conversion") ) {
			SendMessage( hwnd_searchrebar_toolbar_conversion, TB_CHECKBUTTON, ID_SEARCH_CONVERSION_ROMAJI, TRUE );
			SendMessage( hwnd_searchrebar_toolbar_conversion, WM_COMMAND, ID_SEARCH_CONVERSION_ROMAJI, NULL );
		}
		// For kana-insensitive search:
		if( !registry.GetBOOL(".\\Search\\Toolbars\\Kana-sensitive") ) {
			SendMessage( hwnd_searchrebar_toolbar_conversion, TB_CHECKBUTTON, ID_SEARCH_CONVERSION_KANA, TRUE );
			SendMessage( hwnd_searchrebar_toolbar_conversion, WM_COMMAND, ID_SEARCH_CONVERSION_KANA, NULL );
		}
		// Show the processed input?
		if( registry.GetBOOL(".\\Search\\Toolbars\\Show") ) {
			SendMessage( hwnd_searchrebar_toolbar_conversion, TB_CHECKBUTTON, ID_SEARCH_CONVERSION_SHOW, TRUE );
			SendMessage( hwnd_searchrebar_toolbar_conversion, WM_COMMAND, ID_SEARCH_CONVERSION_SHOW, NULL );
		}

		// For the encoding (index):
		SendMessage( hwnd_searchrebar_combobox_encode,CB_SETCURSEL, registry.GetINT(".\\Search\\Toolbars\\Encoding"),0 );
	}
	Log(1,L"Toolbar buttons checked.\n");





	// Select the sort buttons for Results:
	// (the secondary):
	int lparam = registry.GetINT(".\\Results\\Sort2");
	sort_by[SECONDARY].index = -1;
	sort_by[SECONDARY].sortstyle = ASCENDING;
	sort_by[PRIMARY].index = -1;
	sort_by[PRIMARY].sortstyle = ASCENDING;
	if( lparam >= 0 && lparam < HDR_RESULT_MAX ) {
		NMHEADER nmh;
		ZeroMemory( &nmh, sizeof(nmh) );
			nmh.iItem = Header_GetIndexOfItemWithLParamOf( hwnd_resultlist[result_header_items[lparam].hwnd], lparam ); // The index of the item.
			nmh.iButton = 0;
			NMHDR hdr;
			ZeroMemory( &hdr, sizeof(hdr) );
				hdr.code = HDN_ITEMCLICK;
				hdr.hwndFrom = hwnd_resultlist[ result_header_items[lparam].hwnd ];
				hdr.idFrom = 0;
			nmh.hdr = hdr;
		SendMessage( hwnd_resultwindow, WM_NOTIFY, result_header_items[lparam].hwnd==0?WID_RESULT_LIST1:WID_RESULT_LIST2, (LPARAM)&nmh );
		// If it's DESCENDING, click it again.
		if( !registry.GetBOOL(".\\Results\\Sort2 Asc") ) {
			SendMessage( hwnd_resultwindow, WM_NOTIFY, result_header_items[lparam].hwnd==0?WID_RESULT_LIST1:WID_RESULT_LIST2, (LPARAM)&nmh );
		}
	} else {
		Log(L"ERROR: The secondary button to sort on is wrong (%i)\n",lparam );
	}
	// (the primary):
	lparam = registry.GetINT(".\\Results\\Sort1");
	if( lparam >= 0 && lparam < HDR_RESULT_MAX ) {
		NMHEADER nmh;
		ZeroMemory( &nmh, sizeof(nmh) );
			nmh.iItem = Header_GetIndexOfItemWithLParamOf( hwnd_resultlist[result_header_items[lparam].hwnd], lparam ); // The index of the item.
			nmh.iButton = 0;
			NMHDR hdr;
			ZeroMemory( &hdr, sizeof(hdr) );
				hdr.code = HDN_ITEMCLICK;
				hdr.hwndFrom = hwnd_resultlist[ result_header_items[lparam].hwnd ];
				hdr.idFrom = 0;
			nmh.hdr = hdr;
		SendMessage( hwnd_resultwindow, WM_NOTIFY, result_header_items[lparam].hwnd==0?WID_RESULT_LIST1:WID_RESULT_LIST2, (LPARAM)&nmh );
		// If it's DESCENDING, click it again.
		if( !registry.GetBOOL(".\\Results\\Sort1 Asc") ) {
			SendMessage( hwnd_resultwindow, WM_NOTIFY, result_header_items[lparam].hwnd==0?WID_RESULT_LIST1:WID_RESULT_LIST2, (LPARAM)&nmh );
		}
	} else {
		Log(L"ERROR: The primary button to sort on is wrong (%i)\n",lparam );
	}

	// Select the sort buttons for Kanji:
	// (the secondary):
	{
		NMHEADER nmh;
			nmh.iItem = registry.GetINT(".\\Kanji\\Sort2 Button"); // The index of the item.
			nmh.iButton = 0;
			NMHDR hdr;
				hdr.code = HDN_ITEMCLICK;
				hdr.hwndFrom = registry.GetINT(".\\Kanji\\Sort2 Level")==1?hwnd_kanjilist1:hwnd_kanjilist2;
				hdr.idFrom = 0;
			nmh.hdr = hdr;
		SendMessage( hwnd_kanjiwindow, WM_NOTIFY, registry.GetINT(".\\Kanji\\Sort2 Level")==1?WID_KANJI_LIST1:WID_KANJI_LIST2, (LPARAM)&nmh );
		if( !registry.GetBOOL(".\\Kanji\\Sort2 Asc") ) {
			SendMessage( hwnd_kanjiwindow, WM_NOTIFY, registry.GetINT(".\\Kanji\\Sort2 Level")==1?WID_KANJI_LIST1:WID_KANJI_LIST2, (LPARAM)&nmh );
		}
	}
	// (the primary):
	{
		NMHEADER nmh;
			nmh.iItem = registry.GetINT(".\\Kanji\\Sort1 Button"); // The index of the item.
			nmh.iButton = 0;
			NMHDR hdr;
				hdr.code = HDN_ITEMCLICK;
				hdr.hwndFrom = registry.GetINT(".\\Kanji\\Sort1 Level")==1?hwnd_kanjilist1:hwnd_kanjilist2;
				hdr.idFrom = 0;
			nmh.hdr = hdr;
		SendMessage( hwnd_kanjiwindow, WM_NOTIFY, registry.GetINT(".\\Kanji\\Sort1 Level")==1?WID_KANJI_LIST1:WID_KANJI_LIST2, (LPARAM)&nmh );
		if( !registry.GetBOOL(".\\Kanji\\Sort1 Asc") ) {
			SendMessage( hwnd_kanjiwindow, WM_NOTIFY, registry.GetINT(".\\Kanji\\Sort1 Level")==1?WID_KANJI_LIST1:WID_KANJI_LIST2, (LPARAM)&nmh );
		}
	}
	Log(1,L"Result and Kanji Window sort buttons checked.\n");



	// Select the text for ease.
	SendMessage( hwnd_searchedit, EM_SETSEL, 0,-1 );
	SetFocus( hwnd_searchedit );


	// Toggle the IME on/off:
	if( registry.GetBOOL(".\\Misc\\IME") ) {
		// The keyboard stuff doesn't work right...
		//keybd_event(VK_CAPITAL, 0xBA, 0, 0);
		//keybd_event(VK_CAPITAL, 0xBA, KEYEVENTF_KEYUP, 0);
		StartIME();
		SetStatusBarText( 1, L"IME -on-" );
	} else {
		SetStatusBarText( 1, L"IME -off-" );
	}




	// Actually show the main window:
	UpdateWindow(hwnd_mainwindow);
	Log(1,L"Main Window updated.\n");








	if( registry.GetBOOL(".\\Misc\\FirstTime") ) {
		Uint16 text[5000]; swprintf(text,L"\
Hello!! It would appear that this is your first time using JLookUp.\n\
\n\
If you need help, please look at 'index.html' in the Documentation folder.\n\
\n\
With that said...\n\
ABOUT SEARCHING:\n\
(1)\n\
   Use the IME (use CAPSLOCK to turn it on\\off).\n\
\n\
(2)\n\
   Use the old style.\n\
     To search for Japanese text, just type ROMAji or Japanese and press Enter.\n\
          Valid wildcards: _ (anything), and ? (one character).\n\
\n\
     To search for Engish text, type\n\
          EN:EnglishTextHere\n\
     where EngishTextHere is some English text, like:\n\
          to laugh\n\
     or\n\
          happy\n\
     NOTE: English act basically like normaly search-engine searches\n\
     If you want to search for words with EXACTLY the meaning that you want,\n\
     put your search in quotes DIRECTLY after the colon.  For example,\n\
          EN:\"happy\"\n\
\n\
Are you tired of this message?\n\
YES: never show it again.\n\
NO: show it next time, too.");
		int result = MessageBox(hwnd_mainwindow,text,
			L"This is the first time that JLookUp has been opened.",MB_YESNO
		);
		if( result == IDYES ) {
			registry.SetBOOL(".\\Misc\\FirstTime",FALSE);
		}
	}











	// This function has no use anymore:
	InitThreads();

	///////////////////////////////////////////////
	//   Load ALL of the EDICT related stuff:   ///
	///////////////////////////////////////////////
	Load_Thread_LoadAllEDICTS();
	Log(1,L"Load_Thread_LoadAllEDICTS() called.\n");

	{
	MSG msg;
	while( true ) {
		if( !thread_searching ) {  break;  }
		
		PeekMessage( &msg, NULL, 0,0, PM_REMOVE );
		TranslateMessage(&msg);
		//if( msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE ) {  break;  }
		if( msg.message == WM_QUIT ) {  exit(0);  }
		DispatchMessage(&msg);
		Sleep( 10L );
	}
	if( DestroyWindow(hwnd_searching) ) {
		hwnd_searching = NULL;
		Log(1,L"   hwnd_searching destroyed.\n");
	} else {
		Log(L"ERROR: hwnd_searching NOT destroyed.\n");
	}
	RedrawWindow( hwnd_mainwindow, NULL,NULL, RDW_INVALIDATE );
	}//*/
	Log(1,L"Thread finished (assumed to be okay).\n");











	Log(1,L"C O M M E N C I N G    M A I N    M E S S A G E    L O O P\n");

	MSG msg;
   while( GetMessage(&msg, NULL, 0, 0) ) {
		if( msg.message == WM_QUIT ) {  break;  }
      TranslateMessage(&msg);
		if( msg.message == WM_QUIT ) {  break;  }
      DispatchMessage(&msg);
		if( msg.message == WM_QUIT ) {  break;  }
   }

	Log(1,L"E N D    O F    M A I N    M E S S A G E    L O O P\n");




	/////////////////////////////
	///   SAVE THE REGISTRY   ///
	/////////////////////////////
	Log(L"********************************\n");
	Log(L"***   Saving Options.jlreg   ***\n");
	Log(L"********************************\n");
	// Set the values for the window:
	if( registry.GetBOOL(".\\Window\\RememberSize") ) {
		// Get information about the window's placement.
		// We do this to get its correct position & size even if it's minimized.
		WINDOWPLACEMENT wp;
			wp.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement( hwnd_mainwindow, &wp );
		registry.CD(".\\Window");
		registry.SetINT("Window_x", wp.rcNormalPosition.left );
		registry.SetINT("Window_y", wp.rcNormalPosition.top );
		registry.SetINT("Window_w", (wp.rcNormalPosition.right-wp.rcNormalPosition.left) );
		registry.SetINT("Window_h", (wp.rcNormalPosition.bottom-wp.rcNormalPosition.top) );
		registry.SetINT("Div_vert", div_main.GetHalf(DIV_TOP)->GetRECT().bottom );
		registry.SetINT("Div_vert_bottom_horiz", div_main.GetHalf(DIV_BOTTOM)->GetHalf(DIV_LEFT)->GetRECT().right );
	}
	// Set the value for the result-size:
	{
		search_results_max = GetMaxResults();
		registry.SetINT(".\\Results\\Size", search_results_max );
	}
	// Set the values for the buttons:
	{
		// For the Search-type:
		{
			// The button that's down is 'search_style_location'.
			int type = 0;
			switch( search_style_location ) {
				case SEARCH_STYLE_START: {		type = ID_SEARCH_START;		break;  }
				case SEARCH_STYLE_MIDDLE: {	type = ID_SEARCH_MIDDLE;	break;  }
				case SEARCH_STYLE_END: {		type = ID_SEARCH_END;		break;  }
				case SEARCH_STYLE_WHOLE: {		type = ID_SEARCH_WHOLE;		break;  }
			}
			registry.SetINT(".\\Search\\Toolbars\\Type",type );
		}
		// For the match-substrings:
		registry.SetBOOL(".\\Search\\Toolbars\\Substr",search_matchsubstrings==1 );
		// For the search-only-word
		registry.SetBOOL(".\\Search\\Toolbars\\Word",search_forcewordsearch==1 );
		// For ROMAji conversion:
		registry.SetBOOL(".\\Search\\Toolbars\\Romaji-conversion",search_conversion_romaji==1 );
		// For kana-insensitive search:
		registry.SetBOOL(".\\Search\\Toolbars\\Kana-sensitive",search_conversion_kana==0 );
		// Show the processed input?
		registry.SetBOOL(".\\Search\\Toolbars\\Show",search_conversion_show==1 );

		// For the encoding (index):
		registry.SetINT(".\\Search\\Toolbars\\Encoding", SendMessage( hwnd_searchrebar_combobox_encode,CB_GETCURSEL, 0,0 ) );
	}
	// Set the sort-by's for Results:
	registry.SetINT(".\\Results\\Sort1", sort_by[PRIMARY].index );
	registry.SetBOOL(".\\Results\\Sort1 Asc", sort_by[PRIMARY].sortstyle==ASCENDING );

	registry.SetINT(".\\Results\\Sort2", sort_by[SECONDARY].index );
	registry.SetBOOL(".\\Results\\Sort2 Asc", sort_by[SECONDARY].sortstyle==ASCENDING );

	// Set the sort-by's for Kanji:
	registry.SetINT(".\\Kanji\\Sort1 Level", sort_kanji_by[PRIMARY].window_id==WID_KANJI_LIST1?1:2 );
	registry.SetINT(".\\Kanji\\Sort1 Button", sort_kanji_by[PRIMARY].index );
	registry.SetBOOL(".\\Kanji\\Sort1 Asc", sort_kanji_by[PRIMARY].sortstyle==ASCENDING );

	registry.SetINT(".\\Kanji\\Sort2 Level", sort_kanji_by[SECONDARY].window_id==WID_KANJI_LIST1?1:2 );
	registry.SetINT(".\\Kanji\\Sort2 Button", sort_kanji_by[SECONDARY].index );
	registry.SetBOOL(".\\Kanji\\Sort2 Asc", sort_kanji_by[SECONDARY].sortstyle==ASCENDING );


	// Set the information for the Result Window headers:
	SaveResultHeaderInfo();


	// Set the percentages for the Kanji Window headers:
	for( int i = 0; i < 4; i++ ) {
		char path[1024];
			sprintf(path,".\\Kanji\\HeaderWindow1\\Header%i",i );
		HDITEM hditem;
			hditem.mask = HDI_LPARAM;
		Header_GetItem( hwnd_kanjilist1, i, &hditem );
		registry.SetINT(path,(int)(double)hditem.lParam);
	}
	for( i = 0; i < 2; i++ ) {
		char path[1024];
			sprintf(path,".\\Kanji\\HeaderWindow2\\Header%i",i );
		HDITEM hditem;
			hditem.mask = HDI_LPARAM;
		Header_GetItem( hwnd_kanjilist2, i, &hditem );
		registry.SetINT(path,(int)(double)hditem.lParam);
	}


	// Set the IME:
	registry.SetBOOL(".\\Misc\\IME",(ime_start != -1) );


	// Save all of the values to file:
	bool saved = registry.SaveToFile("Options.jlreg");
	if( saved ) {  Log(L"Options.jlreg saved successfully.\n");  }
	else {  Log(L"ERROR while saving Options.jlreg.\n");  }



	Log(L"**************************\n");
	Log(L"***   Cleaning up...   ***\n");
	Log(L"**************************\n");
	// Clean up all of the memory used by the dictionaries:
	for( int d = 0; d < edict_dictionaries.size(); d++ ) {
		Log(L"Deleting EDICT %i / %i...",d+1,edict_dictionaries.size() );
		DeleteEDICT( edict_dictionaries[d] );

		delete edict_dictionaries[d];
		Log(L"OKAY\n");
	}
	Log(L"*********************\n");
	Log(L"***   All done!   ***\n");
	Log(L"*********************\n");


	// Close up the log.
	Log_Close();

   // Shut down GDI:
   GdiplusShutdown(gdiplusToken);
   return( msg.wParam );
}  // WinMain
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
