// Kanji_Copy.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef KANJI_COPY_H
#define KANJI_COPY_H
///////////////////////////////////////////////////////////
// For the copy function:
#include "CopyPaste.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
wstring Kanji_GetOn( KANJIDIC_Entry &entry ) {
	wstring on = L"";
	for( int t = 0; t < entry.on.size(); t++ ) {
		on += entry.on[t];
		if( t < entry.on.size()-1 ) {
			on += L" | ";
		}
	}
	return(on);
}
wstring Kanji_GetKun( KANJIDIC_Entry &entry ) {
	wstring kun = L"";
	for( int t = 0; t < entry.kun.size(); t++ ) {
		kun += entry.kun[t];
		if( t < entry.kun.size()-1 ) {
			kun += L" | ";
		}
	}
	return(kun);
}
wstring Kanji_GetNanori( KANJIDIC_Entry &entry ) {
	wstring nanori = L"";
	for( int t = 0; t < entry.nanori.size(); t++ ) {
		nanori += entry.nanori[t];
		if( t < entry.nanori.size()-1 ) {
			nanori += L" | ";
		}
	}
	return(nanori);
}
wstring Kanji_GetRadicalReadings( KANJIDIC_Entry &entry ) {
	wstring radical = L"";
	for( int t = 0; t < entry.radical.size(); t++ ) {
		radical += entry.radical[t];
		if( t < entry.radical.size()-1 ) {
			radical += L" | ";
		}
	}
	return(radical);
}
wstring Kanji_GetMeaning( KANJIDIC_Entry &entry ) {
	wstring meaning = L"";
	for( int m = 0; m < entry.meanings.size(); m++ ) {
		meaning += entry.meanings[m];
		if( m < entry.meanings.size()-1 ) {
			meaning += L" | ";
		}
	}
	return(meaning);
}
///////////////////////////////////////////////////////////
enum {
	KINFO_KANJI,
	KINFO_ON,
	KINFO_KUN,
	KINFO_NANORI,
	KINFO_RADICALREADING,
	KINFO_MEANING,
	KINFO_ALL
};
///////////////////////////////////////////////////////////
void CopySelectedKanjiInfo( int what ) {
	if( kanji_selected < 0 || kanji_selected >= kanjidic_results.size() ) {  return;  }

	KANJIDIC_Entry *entry = &kanjidic_results[kanji_selected];

	wstring copystr = L"";
	if( what == KINFO_KANJI ) {
		copystr = entry->kanji;
	} else if( what == KINFO_ON ) {
		copystr = Kanji_GetOn( *entry );
	} else if( what == KINFO_KUN ) {
		copystr = Kanji_GetKun( *entry );
	} else if( what == KINFO_NANORI ) {
		copystr = Kanji_GetNanori( *entry );
	} else if( what == KINFO_RADICALREADING ) {
		copystr = Kanji_GetRadicalReadings( *entry );
	} else if( what == KINFO_MEANING ) {
		copystr = Kanji_GetMeaning( *entry );
	} else if( what == KINFO_ALL ) {
		copystr = entry->kanji;
		copystr += L"\nStrokes: ";
			Uint16 str[256]; swprintf(str,L"%i",entry->strokecount );
			copystr += str;
		copystr += L"\nFrequency: ";
			swprintf(str,L"%i",entry->frequency );
			copystr += str;
			copystr += L" / 2501";
		copystr += L"\nOn: ";
			copystr += Kanji_GetOn( *entry );
		copystr += L"\nKun: ";
			copystr += Kanji_GetKun( *entry );
		copystr += L"\nNanori: ";
			copystr += Kanji_GetNanori( *entry );
		copystr += L"\nRadical Readings: ";
			copystr += Kanji_GetRadicalReadings( *entry );
		copystr += L"\nMeaning: ";
			copystr += Kanji_GetMeaning( *entry );
	}


	// Copy the text in the specified format:
	CopyTextUsingComboboxEncoding( copystr );
}
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
