// Kanji_Hover.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef KANJI_HOVER_H
#define KANJI_HOVER_H
///////////////////////////////////////////////////////////
HWND CreateKanji_Hover_Window( HWND hwndParent, int x,int y, int w,int h );
LRESULT CALLBACK WndProc_Kanji_Hover_Window(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
int kanji_hoverwindow_entry;

vector<Uint16> kanji_hover_radicals;

// Fonts for the hover window:
wstring str_font_kanji_hover_kanji = L"MS Mincho";
wstring str_font_kanji_hover_onkun = L"MS Mincho";
wstring str_font_kanji_hover_title = L"Arial";
wstring str_font_kanji_hover_meaning = L"Arial";
wstring str_font_kanji_hover_radical = L"MS Mincho";
int int_font_kanji_hover_kanji = 26;
int int_font_kanji_hover_onkun = 13;
int int_font_kanji_hover_title = 12;
int int_font_kanji_hover_meaning = 14;
int int_font_kanji_hover_radical = 12;

int kanji_hover_bw = 8, kanji_hover_bh = 8; // invisible border sizes.
int kanji_hover_kanji_bw = 10; // space between border and kanji.
int kanji_hover_kanji_spacer = 22; // space between kanji and on.
int kanji_hover_on_spacer = 15; // space between on and kun and nanori and radical.
int kanji_hover_radical_spacer = 30; // space between radical and meaning.

int kanji_hover_strokes_spacer = 30;

int kanji_hover_kanji_spacer_h = 12; // space between kanji and radicals.
int kanji_hover_sf_spacer = 10; // space between stroke count and on.

Uint16 str_kanji_hover_strokes[1024];
Uint16 str_kanji_hover_frequency[1024];
///////////////////////////////////////////////////////////
HWND CreateKanjiHoverWindow( int entry ) {
	if( entry == -1 || entry >= kanjidic_results.size() ) {
		return(NULL);
	}


	str_font_kanji_hover_kanji = ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Kanji\\Font") );
	str_font_kanji_hover_onkun = ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\On\\Font") );
	str_font_kanji_hover_title = ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Meaning\\Font") );
	str_font_kanji_hover_meaning = ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Meaning\\Font") );
	str_font_kanji_hover_radical = ToWString( registry.GetSTRING(".\\Kanji\\Fonts\\Kanji\\Font") );


	kanji_hoverwindow_entry = entry;

	KANJIDIC_Entry *e = &kanjidic_results[entry];

	HDC hdc = GetDC(hwnd_kanjiwindow);
	Graphics graphics( hdc );

		Font font_kanji_hover_kanji( str_font_kanji_hover_kanji.c_str(), int_font_kanji_hover_kanji );
		Font font_kanji_hover_onkun( str_font_kanji_hover_onkun.c_str(), int_font_kanji_hover_onkun );
		Font font_kanji_hover_title( str_font_kanji_hover_title.c_str(), int_font_kanji_hover_title );
		Font font_kanji_hover_meaning( str_font_kanji_hover_meaning.c_str(), int_font_kanji_hover_meaning );
		Font font_kanji_hover_radical( str_font_kanji_hover_radical.c_str(), int_font_kanji_hover_radical );
		

		StringFormat format(0);//(StringFormatFlagsNoWrap);
			format.SetTrimming( StringTrimmingNone );

	SizeF sizef( 600,400 );

	int kanji_width = 0, kanji_height = 0;
	{
		SizeF stringsizef;
		graphics.MeasureString(
			&e->kanji, 1,
			&font_kanji_hover_kanji,
			sizef,
			&format,
			&stringsizef
		);
		kanji_width = max( kanji_width, stringsizef.Width );
		kanji_height += stringsizef.Height;
	}

	int on_width = 0, on_height = 0;
	// Title for on:
	{
		SizeF stringsizef;
		graphics.MeasureString(
			L"On", 2,
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		on_width = max( on_width, stringsizef.Width );
		on_height += stringsizef.Height;
	}
	for( int i = 0; i < e->on.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->on[i].c_str(), e->on[i].size(),
			&font_kanji_hover_onkun,
			sizef,
			&format,
			&stringsizef
		);
		on_width = max( on_width, stringsizef.Width );
		on_height += stringsizef.Height;
	}

	int kun_width = 0, kun_height = 0;
	// Title for kun:
	{
		SizeF stringsizef;
		graphics.MeasureString(
			L"Kun", 3,
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		kun_width = max( kun_width, stringsizef.Width );
		kun_height += stringsizef.Height;
	}
	for( i = 0; i < e->kun.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->kun[i].c_str(), e->kun[i].size(),
			&font_kanji_hover_onkun,
			sizef,
			&format,
			&stringsizef
		);
		kun_width = max( kun_width, stringsizef.Width );
		kun_height += stringsizef.Height;
	}


	int nanori_width = 0, nanori_height = 0;
	// Title for nanori:
	{
		SizeF stringsizef;
		graphics.MeasureString(
			L"Nanori", 6,
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		nanori_width = max( nanori_width, stringsizef.Width );
		nanori_height += stringsizef.Height;
	}
	for( i = 0; i < e->nanori.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->nanori[i].c_str(), e->nanori[i].size(),
			&font_kanji_hover_onkun,
			sizef,
			&format,
			&stringsizef
		);
		nanori_width = max( nanori_width, stringsizef.Width );
		nanori_height += stringsizef.Height;
	}



	int radical_width = 0, radical_height = 0;
	// Title for radical:
	{
		SizeF stringsizef;
		graphics.MeasureString(
			L"Radical", 7,
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		radical_width = max( radical_width, stringsizef.Width );
		radical_height += stringsizef.Height;
	}
	for( i = 0; i < e->radical.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->radical[i].c_str(), e->radical[i].size(),
			&font_kanji_hover_onkun,
			sizef,
			&format,
			&stringsizef
		);
		radical_width = max( radical_width, stringsizef.Width );
		radical_height += stringsizef.Height;
	}



	// Meanings:
	int meaning_width = 0, meaning_height = 0;
	for( i = 0; i < e->meanings.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->meanings[i].c_str(), e->meanings[i].size(),
			&font_kanji_hover_meaning,
			sizef,
			&format,
			&stringsizef
		);
		meaning_width = max( meaning_width, stringsizef.Width );
		meaning_height += stringsizef.Height;
	}








	// Radicals:
	kanji_hover_radicals.clear();
	for( int r = 0; r < radical_info_size; r++ ) {
		for( int u = 0; u < radical_info[r].relatedkanji_size; u++ ) {
			if( radical_info[r].relatedkanji[u] == e->kanji ) {
				kanji_hover_radicals.push_back( radical_info[r].radical );
				break;
			}
		}
	}
	int rads_width = 0, rads_height = 0;
	// Title for rads:
	{
		SizeF stringsizef;
		graphics.MeasureString(
			L"Radicals", 8,
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		rads_width = max( rads_width, stringsizef.Width );
		rads_height += stringsizef.Height;
	}
	for( i = 0; i < kanji_hover_radicals.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			&kanji_hover_radicals[i], 1,
			&font_kanji_hover_radical,
			sizef,
			&format,
			&stringsizef
		);
		rads_width = max( rads_width, stringsizef.Width );
		rads_height += stringsizef.Height;
	}




	// Stroke count:
	swprintf( str_kanji_hover_strokes, L"Strokes: %i",e->strokecount );
	int strokes_width = 0, strokes_height = 0;
	{
		SizeF stringsizef;
		graphics.MeasureString(
			str_kanji_hover_strokes, wcslen(str_kanji_hover_strokes),
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		strokes_width = max( strokes_width, stringsizef.Width );
		strokes_height += stringsizef.Height;
	}

	// Frequency:
	swprintf( str_kanji_hover_frequency, L"Frequency: %i / 2501",e->frequency );
	int freq_width = 0, freq_height = 0;
	{
		SizeF stringsizef;
		graphics.MeasureString(
			str_kanji_hover_frequency, wcslen(str_kanji_hover_frequency),
			&font_kanji_hover_title,
			sizef,
			&format,
			&stringsizef
		);
		freq_width = max( freq_width, stringsizef.Width );
		freq_height += stringsizef.Height;
	}

	int sf_height = max( strokes_height, freq_height ) + kanji_hover_sf_spacer;




	int width =
		kanji_hover_bw +
			kanji_hover_kanji_bw +
		max( kanji_width, rads_width ) + 
			kanji_hover_kanji_spacer + 
		max( 
			on_width + 
				kanji_hover_on_spacer + 
			kun_width + 
				kanji_hover_on_spacer + 
			nanori_width + 
				kanji_hover_on_spacer + 
			radical_width + 
				kanji_hover_radical_spacer + 
			meaning_width,										strokes_width+kanji_hover_strokes_spacer+freq_width
		) +
		kanji_hover_bw;
	int height = 
		kanji_hover_bh +
		max(
			max(
				max(
					max(
						max( kanji_height+kanji_hover_kanji_spacer_h+rads_height, sf_height+on_height ),
						sf_height+kun_height
					),
					sf_height+nanori_height
				),
				sf_height+radical_height
			),
			sf_height+meaning_height
		) + 
		kanji_hover_bh;


	HWND hwnd_hover = CreateKanji_Hover_Window( hwnd_kanjiwindow, 0,0, width,height );
	return( hwnd_hover );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc_Kanji_Hover_Window(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	static bool tracking = false;

	static POINT hover_pos;
	static int hover_entry;

	switch( message ) {
		case WM_CREATE: {
			return(0);
		}
		case WM_SIZE: {
			return( 0 );
		}
		case WM_NOTIFY: {
			return(0);
		}
		case WM_PAINT: {
			HDC hdc;
			PAINTSTRUCT ps;
	      hdc = BeginPaint(hWnd, &ps);
				Graphics graphics(hdc);

				KANJIDIC_Entry *e = &kanjidic_results[kanji_hoverwindow_entry];

					{
						SolidBrush brush_bg( color_kanji_bg1 );

						RECT rcClient; GetClientRect( hWnd, &rcClient );
						RectF rcFill;
							rcFill.X = rcClient.left;
							rcFill.Y = rcClient.top;
							rcFill.Width = rcClient.right;
							rcFill.Height = rcClient.bottom;
						graphics.FillRectangle( &brush_bg, rcFill );
					}

				Font font_kanji_hover_kanji( str_font_kanji_hover_kanji.c_str(), int_font_kanji_hover_kanji );
				Font font_kanji_hover_onkun( str_font_kanji_hover_onkun.c_str(), int_font_kanji_hover_onkun );
				Font font_kanji_hover_title( str_font_kanji_hover_title.c_str(), int_font_kanji_hover_title );
				Font font_kanji_hover_meaning( str_font_kanji_hover_meaning.c_str(), int_font_kanji_hover_meaning );
				Font font_kanji_hover_radical( str_font_kanji_hover_radical.c_str(), int_font_kanji_hover_radical );

				SolidBrush brush_word( color_kanji );
				SolidBrush brush_on( color_kanji_on );
				SolidBrush brush_kun( color_kanji_kun );
				SolidBrush brush_title( color_kanji );
				SolidBrush brush_meaning( color_kanji_meaning );
				SolidBrush brush_radical( Color(0,128,255) );
				SolidBrush brush_info( Color(255,0,128) );

				StringFormat format(0);//(StringFormatFlagsNoWrap);
					format.SetTrimming( StringTrimmingNone );


					RECT rcClient;
						GetClientRect( hWnd, &rcClient );
					graphics.DrawRectangle( &Pen( Color(0,0,255), 2 ), 1,1, rcClient.right-2,rcClient.bottom-2 );
					
					graphics.FillRectangle( &SolidBrush( Color(128,128,255) ), 2,2, kanji_hover_bw-1+kanji_hover_bw, rcClient.bottom-2-2 );


				SizeF sizef( 600,400 );

				int x,y;

				x = kanji_hover_bw+kanji_hover_kanji_bw; y = kanji_hover_bh;
				// The Kanji:
				int kanji_width = 0, kanji_height = 0;
				{
					SizeF stringsizef;
					graphics.MeasureString(
						&e->kanji, 1,
						&font_kanji_hover_kanji,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						&e->kanji, 1,
						&font_kanji_hover_kanji,
						PointF( x, y ),
						&format,
						&brush_word
					);

					kanji_width = max( kanji_width, stringsizef.Width );
					kanji_height += stringsizef.Height;
				}




				// Radicals:
				int rads_width = 0, rads_height = 0;
				// Title for rads:
				{
					SizeF stringsizef;
					graphics.MeasureString(
						L"Radicals", 8,
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						L"Radicals", 8,
						&font_kanji_hover_title,
						PointF( x, y+kanji_height+kanji_hover_kanji_spacer_h+rads_height ),
						&format,
						&brush_meaning
					);

					rads_width = max( rads_width, stringsizef.Width );
					rads_height += stringsizef.Height;
				}
				for( int i = 0; i < kanji_hover_radicals.size(); i++ ) {
					//fprintf(g_flog,"Drawing radical %i of %i\n",i,kanji_hover_radicals.size() );
					SizeF stringsizef;
					graphics.MeasureString(
						&kanji_hover_radicals[i], 1,
						&font_kanji_hover_radical,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						&kanji_hover_radicals[i], 1,
						&font_kanji_hover_radical,
						PointF( x, y+kanji_height+kanji_hover_kanji_spacer_h+rads_height ),
						&format,
						&brush_radical
					);

					rads_width = max( rads_width, stringsizef.Width );
					rads_height += stringsizef.Height;
				}


				x += max(kanji_width,rads_width) + kanji_hover_kanji_spacer;

				// Stroke count:
				int strokes_width = 0, strokes_height = 0;
				{
					SizeF stringsizef;
					graphics.MeasureString(
						str_kanji_hover_strokes, wcslen(str_kanji_hover_strokes),
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						str_kanji_hover_strokes, wcslen(str_kanji_hover_strokes),
						&font_kanji_hover_title,
						PointF( x, y ),
						&format,
						&brush_info
					);

					strokes_width = max( strokes_width, stringsizef.Width );
					strokes_height += stringsizef.Height;
				}

				// Frequency:
				int freq_width = 0, freq_height = 0;
				{
					SizeF stringsizef;
					graphics.MeasureString(
						str_kanji_hover_frequency, wcslen(str_kanji_hover_frequency),
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						str_kanji_hover_frequency, wcslen(str_kanji_hover_frequency),
						&font_kanji_hover_title,
						PointF( x + strokes_width+kanji_hover_strokes_spacer, y ),
						&format,
						&brush_info
					);


					freq_width = max( freq_width, stringsizef.Width );
					freq_height += stringsizef.Height;
				}

				int sf_height = max( strokes_height, freq_height ) + kanji_hover_sf_spacer;



				y += sf_height;

				int on_width = 0, on_height = 0;
				// Title for on:
				{
					SizeF stringsizef;
					graphics.MeasureString(
						L"On", 2,
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						L"On", 2,
						&font_kanji_hover_title,
						PointF( x, y+on_height ),
						&format,
						&brush_title
					);

					on_width = max( on_width, stringsizef.Width );
					on_height += stringsizef.Height;
				}
				for( i = 0; i < e->on.size(); i++ ) {
					SizeF stringsizef;
					graphics.MeasureString(
						e->on[i].c_str(), e->on[i].size(),
						&font_kanji_hover_onkun,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						e->on[i].c_str(), e->on[i].size(),
						&font_kanji_hover_onkun,
						PointF( x, y+on_height ),
						&format,
						&brush_on
					);

					on_width = max( on_width, stringsizef.Width );
					on_height += stringsizef.Height;
				}


				x += on_width + kanji_hover_on_spacer;
				int kun_width = 0, kun_height = 0;
				// Title for kun:
				{
					SizeF stringsizef;
					graphics.MeasureString(
						L"Kun", 3,
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						L"Kun", 3,
						&font_kanji_hover_title,
						PointF( x, y+kun_height ),
						&format,
						&brush_title
					);

					kun_width = max( kun_width, stringsizef.Width );
					kun_height += stringsizef.Height;
				}
				for( i = 0; i < e->kun.size(); i++ ) {
					SizeF stringsizef;
					graphics.MeasureString(
						e->kun[i].c_str(), e->kun[i].size(),
						&font_kanji_hover_onkun,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						e->kun[i].c_str(), e->kun[i].size(),
						&font_kanji_hover_onkun,
						PointF( x, y+kun_height ),
						&format,
						&brush_kun
					);

					kun_width = max( kun_width, stringsizef.Width );
					kun_height += stringsizef.Height;
				}



				x += kun_width + kanji_hover_on_spacer;
				int nanori_width = 0, nanori_height = 0;
				// Title for nanori:
				{
					SizeF stringsizef;
					graphics.MeasureString(
						L"Nanori", 6,
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						L"Nanori", 6,
						&font_kanji_hover_title,
						PointF( x, y+nanori_height ),
						&format,
						&brush_title
					);

					nanori_width = max( nanori_width, stringsizef.Width );
					nanori_height += stringsizef.Height;
				}
				for( i = 0; i < e->nanori.size(); i++ ) {
					SizeF stringsizef;
					graphics.MeasureString(
						e->nanori[i].c_str(), e->nanori[i].size(),
						&font_kanji_hover_onkun,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						e->nanori[i].c_str(), e->nanori[i].size(),
						&font_kanji_hover_onkun,
						PointF( x, y+nanori_height ),
						&format,
						&brush_on
					);

					nanori_width = max( nanori_width, stringsizef.Width );
					nanori_height += stringsizef.Height;
				}



				x += nanori_width + kanji_hover_on_spacer;
				int radical_width = 0, radical_height = 0;
				// Title for radical:
				{
					SizeF stringsizef;
					graphics.MeasureString(
						L"Radical", 7,
						&font_kanji_hover_title,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						L"Radical", 7,
						&font_kanji_hover_title,
						PointF( x, y+radical_height ),
						&format,
						&brush_title
					);

					radical_width = max( radical_width, stringsizef.Width );
					radical_height += stringsizef.Height;
				}
				for( i = 0; i < e->radical.size(); i++ ) {
					SizeF stringsizef;
					graphics.MeasureString(
						e->radical[i].c_str(), e->radical[i].size(),
						&font_kanji_hover_onkun,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						e->radical[i].c_str(), e->radical[i].size(),
						&font_kanji_hover_onkun,
						PointF( x, y+radical_height ),
						&format,
						&brush_kun
					);

					radical_width = max( radical_width, stringsizef.Width );
					radical_height += stringsizef.Height;
				}



				x += radical_width + kanji_hover_radical_spacer;
				// Meanings:
				int meaning_width = 0, meaning_height = 0;
				for( i = 0; i < e->meanings.size(); i++ ) {
					SizeF stringsizef;
					graphics.MeasureString(
						e->meanings[i].c_str(), e->meanings[i].size(),
						&font_kanji_hover_meaning,
						sizef,
						&format,
						&stringsizef
					);

					graphics.DrawString(
						e->meanings[i].c_str(), e->meanings[i].size(),
						&font_kanji_hover_meaning,
						PointF( x, y+meaning_height ),
						&format,
						&brush_meaning
					);

					graphics.FillRectangle(
						&SolidBrush( Color(60,60,60) ),
						(INT)(x - 10),
						(INT)(y+meaning_height + stringsizef.Height/2-3),
						(INT)6,(INT)6
					);

					meaning_width = max( meaning_width, stringsizef.Width );
					meaning_height += stringsizef.Height;
				}

		   EndPaint(hWnd, &ps);
			return(0); // An application should return 0 if it processes WM_PAINT.
		}//*/
		/*case WM_ERASEBKGND: {
			// An application should return 0 if it did NOT erase the backgound.
			// Here, we're faking that we did, so...
			return(TRUE);
		}//*/
		case WM_LBUTTONDOWN: {
			return(0); // An application should return 0 if it processes WM_LBUTTONDOWN.
		}
		case WM_LBUTTONDBLCLK: {
			// wParam :: what virtual keys are down.
			// lParam :: LONG( x, y ).
			return(0); // An application should return 0 if it processes WM_LBUTTONDBLCLK.
		}
		case WM_RBUTTONDOWN: {
			return(0); // An application should return 0 if it processes WM_RBUTTONDOWN.
		}
		case WM_MOUSEMOVE: {
			int mx = LOWORD(lParam), my = HIWORD(lParam);
			return(0); // An application should return 0 if it processes WM_MOUSEMOVE.
		}
		case WM_MOUSEHOVER: {
			return(0);
		}
		case WM_KEYDOWN: {
			return(0);
		}
	}
	return( DefWindowProc(hWnd, message, wParam, lParam) );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateKanji_Hover_Window( HWND hwndParent, int x,int y, int w,int h ) {
	WNDCLASS wndClass; 
	   //wndClass.style          = CS_SAVEBITS; //CS_HREDRAW | CS_VREDRAW;
		wndClass.style          = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wndClass.lpfnWndProc    = WndProc_Kanji_Hover_Window;
	   wndClass.cbClsExtra     = 0;
		wndClass.cbWndExtra     = 0;
	   wndClass.hInstance      = g_hinst;
		wndClass.hIcon          = NULL;//LoadIcon(NULL, IDI_APPLICATION);
	   wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
		wndClass.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
	   wndClass.lpszMenuName   = NULL;
		wndClass.lpszClassName  = TEXT("Kanji_Hover_Window");
   
   RegisterClass( &wndClass );
   
   HWND hWnd = CreateWindowEx(
		0,
      TEXT("Kanji_Hover_Window"),   // window class name
      TEXT("(Kanji_Hover_Window)"),  // window caption
      WS_POPUP, // window style
      x,y, // (x,y)
      w,h, // (w,h)
      hwndParent,                     // parent window handle
      NULL,                     // window menu handle
      g_hinst,                // program instance handle
      NULL                    // creation parameters
	);
	  
   //ShowWindow(hWnd, SW_SHOW);
	return(hWnd);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
