// MakeNewOptionsFile.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef MAKENEWOPTIONSFILE_H
#define MAKENEWOPTIONSFILE_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
bool MakeNewOptionsFile( char *path ) {
	FILE *file = fopen(path,"wt");
	if( !file ) {
		MessageBox(NULL,L"Couldn't create a new options file.",L"Error",MB_OK );
		return(false);
	}

	fprintf(file,"\
#\n\
# JLookUp options file (v2)\n\
#\n\
KEY_START :: Window\n\
	BOOL :: RememberSize :: FALSE\n\
	INT :: Window_x :: 352\n\
	INT :: Window_y :: 213\n\
	INT :: Window_w :: 800\n\
	INT :: Window_h :: 600\n\
	INT :: Div_vert :: 145\n\
	INT :: Div_vert_bottom_horiz :: 220\n\
KEY_STOP\n\
KEY_START :: Search\n\
	KEY_START :: Font\n\
		STRING :: Font :: Arial\n\
		INT :: Size :: 9\n\
		INT :: Color :: 0\n\
	KEY_STOP\n\
	KEY_START :: Toolbars\n\
		INT :: Type :: 40007\n\
		BOOL :: Substr :: FALSE\n\
		BOOL :: Word :: FALSE\n\
		BOOL :: Fuzzy :: FALSE\n\
		BOOL :: Romaji-conversion :: FALSE\n\
		BOOL :: Kana-sensitive :: FALSE\n\
		BOOL :: Show :: TRUE\n\
		INT :: Encoding :: 1\n\
	KEY_STOP\n\
	INT :: WindowBG :: 16777215\n\
	BOOL :: ShowInitialText :: TRUE\n\
	BOOL :: AlwaysSearchFocus :: FALSE\n\
	INT :: Language :: 40024\n\
KEY_STOP\n");
	fprintf(file,"\
KEY_START :: Dictionaries\n\
#\n\
# Dictionaries\n\
#\n\
	KEY_START :: EDICT\n\
		KEY_START :: 0\n\
			STRING :: Path :: DICT\\edict\n\
			STRING :: Name :: Standard EDICT\n\
			STRING :: Encoding :: EUC-JP\n\
			BOOL :: On :: TRUE\n\
		KEY_STOP\n\
		INT :: Number :: 1\n\
	KEY_STOP\n\
	KEY_START :: KANJIDIC\n\
		STRING :: Path :: DICT\\kanjidic\n\
		STRING :: Name :: Standard KANJIDIC\n\
	KEY_STOP\n\
	KEY_START :: RADKFILE\n\
		STRING :: Path :: radkfile.dat\n\
	KEY_STOP\n\
	BOOL :: Indexing :: TRUE\n\
KEY_STOP\n\
KEY_START :: Buffer\n\
#\n\
# Buffers\n\
#\n\
	INT :: EDICT :: 5000\n\
	INT :: KANJIDIC :: 2000\n\
	INT :: RADKFILE :: 1000\n\
KEY_STOP\n\
");
fprintf(file,"\n\
KEY_START :: Results\n\
#\n\
# Results\n\
#\n\
	KEY_START :: Fonts\n\
		KEY_START :: Word\n\
			STRING :: Font :: MS Mincho\n\
			INT :: Size :: 12\n\
			INT :: Color :: 8388608\n\
		KEY_STOP\n\
		KEY_START :: Kana\n\
			STRING :: Font :: MS Mincho\n\
			INT :: Size :: 12\n\
			INT :: Color :: 0\n\
		KEY_STOP\n\
		KEY_START :: Meaning\n\
			STRING :: Font :: Arial\n\
			INT :: Size :: 8\n\
			INT :: Color :: 0\n\
		KEY_STOP\n\
		KEY_START :: Info\n\
			STRING :: Font :: Times New Roman\n\
			INT :: Size :: 8\n\
			INT :: Color :: 7347451\n\
		KEY_STOP\n\
	KEY_STOP\n\
	KEY_START :: Colors\n\
		INT :: BG1 :: 16777215\n\
		INT :: BG2 :: 12632256\n\
		INT :: BGWindow :: 16777215\n\
		INT :: Border_Inside :: 8421440\n\
		INT :: Border_Outside :: 0\n\
	KEY_STOP\n\
	KEY_START :: HeaderItems\n\
		KEY_START :: 0\n\
# Word\n\
			INT :: Header :: 0\n\
			INT :: Percentage :: 30\n\
			INT :: Position :: 0\n\
		KEY_STOP\n\
		KEY_START :: 1\n\
# Kana\n\
			INT :: Header :: 1\n\
			INT :: Percentage :: 30\n\
			INT :: Position :: 0\n\
		KEY_STOP\n\
		KEY_START :: 2\n\
# Info\n\
			INT :: Header :: 0\n\
			INT :: Percentage :: 60\n\
			INT :: Position :: 1\n\
		KEY_STOP\n\
		KEY_START :: 3\n\
# Meaning\n\
			INT :: Header :: 1\n\
			INT :: Percentage :: 70\n\
			INT :: Position :: 1\n\
		KEY_STOP\n\
		KEY_START :: 4\n\
# Word Length\n\
			INT :: Header :: 0\n\
			INT :: Percentage :: 5\n\
			INT :: Position :: 2\n\
		KEY_STOP\n\
		KEY_START :: 5\n\
# Kana Length\n\
			INT :: Header :: 0\n\
			INT :: Percentage :: 5\n\
			INT :: Position :: 3\n\
		KEY_STOP\n\
	KEY_STOP\n\
	KEY_START :: Copy\n\
		STRING :: Format :: {%word (%kana) \\:\\: %meaning}\n\
		STRING :: SepInfo :: {, }\n\
		STRING :: SepMeaning :: { | }\n\
		STRING :: SepMultiple :: {\n}\n\
	KEY_STOP\n\
	INT :: Size :: 200\n\
	INT :: Sort1 :: 1\n\
	BOOL :: Sort1 Asc :: TRUE\n\
	INT :: Sort2 :: 0\n\
	BOOL :: Sort2 Asc :: TRUE\n\
KEY_STOP\n\
");
fprintf(file,"\n\
KEY_START :: Kanji\n\
#\n\
# Kanji\n\
#\n\
	KEY_START :: Fonts\n\
		KEY_START :: Kanji\n\
			STRING :: Font :: MS Mincho\n\
			INT :: Size :: 24\n\
			INT :: Color :: 8388608\n\
		KEY_STOP\n\
		KEY_START :: On\n\
			STRING :: Font :: MS Mincho\n\
			INT :: Size :: 10\n\
			INT :: Color :: 1210497\n\
		KEY_STOP\n\
		KEY_START :: Kun\n\
			INT :: Color :: 2433279\n\
		KEY_STOP\n\
		KEY_START :: Meaning\n\
			STRING :: Font :: Arial\n\
			INT :: Size :: 8\n\
			INT :: Color :: 0\n\
		KEY_STOP\n\
	KEY_STOP\n\
	KEY_START :: Colors\n\
		INT :: BG1 :: 16777215\n\
		INT :: BG2 :: 12632256\n\
		INT :: BGWindow :: 16777215\n\
		INT :: Border_Inside :: 8421504\n\
		INT :: Border_Outside :: 0\n\
	KEY_STOP\n\
	KEY_START :: HeaderWindow1\n\
		INT :: Header0 :: 20\n\
		INT :: Header1 :: 34\n\
		INT :: Header2 :: 34\n\
		INT :: Header3 :: 11\n\
	KEY_STOP\n\
	KEY_START :: HeaderWindow2\n\
		INT :: Header0 :: 20\n\
		INT :: Header1 :: 80\n\
	KEY_STOP\n\
	INT :: Sort1 Level :: 1\n\
	INT :: Sort1 Button :: 0\n\
	BOOL :: Sort1 Asc :: TRUE\n\
	INT :: Sort2 Level :: 1\n\
	INT :: Sort2 Button :: 3\n\
	BOOL :: Sort2 Asc :: TRUE\n\
KEY_STOP\n\
KEY_START :: RadicalLookup\n\
#\n\
# Radical Lookup\n\
#\n\
	BOOL :: CtrlClick :: FALSE\n\
KEY_STOP\n\
KEY_START :: Misc\n\
	KEY_START :: Font\n\
		STRING :: Font :: Arial\n\
		INT :: Size :: 8\n\
	KEY_STOP\n\
	BOOL :: FirstTime :: TRUE\n\
	BOOL :: AlwaysOnTop :: FALSE\n\
	BOOL :: GrabClipboard :: FALSE\n\
	BOOL :: GrabClipboard-AutoSearch :: FALSE\n\
	STRING :: Version :: 1.0.7.3d\n\
	BOOL :: IME :: TRUE\n\
	BOOL :: ROMAjiMode :: FALSE\n\
KEY_STOP\n\
");

	fclose(file);
	return(true);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
