// Result_Hover.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef RESULT_HOVER_H
#define RESULT_HOVER_H
///////////////////////////////////////////////////////////
HWND CreateResult_Hover_Window( HWND hwndParent, int x,int y, int w,int h );
LRESULT CALLBACK WndProc_Result_Hover_Window(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
int hoverwindow_entry;

// Fonts for the hover window:
wstring str_font_hover_word = L"MS Mincho";
wstring str_font_hover_kana = L"MS Mincho";
wstring str_font_hover_meaning = L"Arial";
wstring str_font_hover_info = L"Arial";
int int_font_hover_word = 18;
int int_font_hover_kana = 18;
int int_font_hover_meaning = 14;
int int_font_hover_info = 12;

int hover_bw = 8, hover_bh = 8;
int hover_word_bw = 10;
int hover_word_spacer = 22;
int hover_info_spacer = 10;
///////////////////////////////////////////////////////////
HWND CreateResultHoverWindow( int entry ) {
	if( entry == -1 || entry >= edict_results.size() ) {
		return(NULL);
	}

	str_font_hover_word = ToWString( registry.GetSTRING(".\\Results\\Fonts\\Word\\Font") );
	str_font_hover_kana = ToWString( registry.GetSTRING(".\\Results\\Fonts\\Kana\\Font") );
	str_font_hover_meaning = ToWString( registry.GetSTRING(".\\Results\\Fonts\\Meaning\\Font") );
	str_font_hover_info = ToWString( registry.GetSTRING(".\\Results\\Fonts\\Info\\Font") );


	hoverwindow_entry = entry;

	EDICT_Entry *e = &edict_results[entry];

	HDC hdc = GetDC(hwnd_resultwindow);
	Graphics graphics( hdc );

		Font font_hover_word( str_font_hover_word.c_str(), int_font_hover_word );
		Font font_hover_kana( str_font_hover_kana.c_str(), int_font_hover_kana );
		
		int int_font_hover_meaning_old = int_font_hover_meaning;
		if( e->meaning.size() > 12 ) {  int_font_hover_meaning = int_font_hover_meaning * 2 / 3;  }
		else {
			for( int i = 0; i < e->meaning.size(); i++ ) {
				if( e->meaning[i].size() > 40 ) {
					int_font_hover_meaning = int_font_hover_meaning * 2 / 3;
					break;
				}
			}
		}
		Font font_hover_meaning( str_font_hover_meaning.c_str(), int_font_hover_meaning );
		int_font_hover_meaning = int_font_hover_meaning_old;
		
		Font font_hover_info( str_font_hover_info.c_str(), int_font_hover_info );

		StringFormat format(0);//(StringFormatFlagsNoWrap);
			format.SetTrimming( StringTrimmingNone );

	SizeF sizef( 600,400 );

	int word_width = 0;
	int word_height = 0;
	{
		SizeF stringsizef;
		graphics.MeasureString(
			e->word.c_str(),
			e->word.size(),
			&font_hover_word,
			sizef,
			&format,
			&stringsizef
		);
		word_width = max( word_width, stringsizef.Width );
		word_height += stringsizef.Height;
	}
	{
		SizeF stringsizef;
		graphics.MeasureString(
			e->kana.c_str(),
			e->kana.size(),
			&font_hover_kana,
			sizef,
			&format,
			&stringsizef
		);
		word_width = max( word_width, stringsizef.Width );
		word_height += stringsizef.Height;
	}


	int info_width = 0;
	int info_height = 0;
	for( int i = 0; i < e->info.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->info[i].c_str(),
			e->info[i].size(),
			&font_hover_info,
			sizef,
			&format,
			&stringsizef
		);
		info_width = max( info_width, stringsizef.Width );
		info_height += stringsizef.Height;
	}



	int meaning_width = 0;
	int meaning_height = 0;
	for( i = 0; i < e->meaning.size(); i++ ) {
		SizeF stringsizef;
		graphics.MeasureString(
			e->meaning[i].c_str(),
			e->meaning[i].size(),
			&font_hover_meaning,
			sizef,
			&format,
			&stringsizef
		);
		meaning_width = max( meaning_width, stringsizef.Width );
		meaning_height += stringsizef.Height;
	}

	int width = hover_bw + hover_word_bw + word_width + hover_word_spacer + max(info_width,meaning_width) + hover_bw;
	int height = hover_bh + max(word_height,info_height+hover_info_spacer+meaning_height) + hover_bh;

	HWND hwnd_hover = CreateResult_Hover_Window( hwnd_resultwindow, 0,0, width,height );
	return( hwnd_hover );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc_Result_Hover_Window(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	static bool tracking = false;

	static POINT hover_pos;
	static int hover_entry;

	switch( message ) {
		case WM_CREATE: {
			return(0);
		}
		case WM_SIZE: {
			return( 0 );
		}
		case WM_NOTIFY: {
			return(0);
		}
		case WM_PAINT: {
			HDC hdc;
			PAINTSTRUCT ps;
	      hdc = BeginPaint(hWnd, &ps);
				Graphics graphics(hdc);

				EDICT_Entry *e = &edict_results[hoverwindow_entry];


					{
						SolidBrush brush_bg( color_result_bg1 );

						RECT rcClient; GetClientRect( hWnd, &rcClient );
						RectF rcFill;
							rcFill.X = rcClient.left;
							rcFill.Y = rcClient.top;
							rcFill.Width = rcClient.right;
							rcFill.Height = rcClient.bottom;
						graphics.FillRectangle( &brush_bg, rcFill );
					}

					Font font_hover_word( str_font_hover_word.c_str(), int_font_hover_word );
					Font font_hover_kana( str_font_hover_kana.c_str(), int_font_hover_kana );
					
					int int_font_hover_meaning_old = int_font_hover_meaning;
					if( e->meaning.size() > 12 ) {  int_font_hover_meaning = int_font_hover_meaning * 2 / 3;  }
					else {
						for( int i = 0; i < e->meaning.size(); i++ ) {
							if( e->meaning[i].size() > 40 ) {
								int_font_hover_meaning = int_font_hover_meaning * 2 / 3;
								break;
							}
						}
					}
					Font font_hover_meaning( str_font_hover_meaning.c_str(), int_font_hover_meaning );
					int_font_hover_meaning = int_font_hover_meaning_old;
					
					Font font_hover_info( str_font_hover_info.c_str(), int_font_hover_info );

					// This is for the background of the window:
					SolidBrush brush_result_bg( color_result_windowbg );

					SolidBrush brush_word( color_result_word );
					SolidBrush brush_kana( color_result_kana );
					SolidBrush brush_meaning( color_result_meaning );
					SolidBrush brush_info( color_result_info );

					StringFormat format(0);//(StringFormatFlagsNoWrap);
						format.SetTrimming( StringTrimmingNone );



					RECT rcClient;
						GetClientRect( hWnd, &rcClient );
					graphics.DrawRectangle( &Pen( Color(0,0,255), 2 ), 1,1, rcClient.right-2,rcClient.bottom-2 );
					
					graphics.FillRectangle( &SolidBrush( Color(128,128,255) ), 2,2, hover_bw-1+hover_word_bw, rcClient.bottom-2-2 );

					SizeF sizef( 600,400 );

					int word_width = 0;
					int word_height = 0;
					{
						SizeF stringsizef;
						graphics.MeasureString(
							e->word.c_str(),
							e->word.size(),
							&font_hover_word,
							sizef,
							&format,
							&stringsizef
						);

						graphics.DrawString(
							e->word.c_str(),
							e->word.size(),
							&font_hover_word,
							PointF( hover_bw+hover_word_bw, hover_bh ),
							&format,
							&brush_word
						);


						word_width = max( word_width, stringsizef.Width );
						word_height += stringsizef.Height;
					}
					{
						SizeF stringsizef;
						graphics.MeasureString(
							e->kana.c_str(),
							e->kana.size(),
							&font_hover_kana,
							sizef,
							&format,
							&stringsizef
						);

						graphics.DrawString(
							e->kana.c_str(),
							e->kana.size(),
							&font_hover_kana,
							PointF( hover_bw+hover_word_bw, hover_bh+word_height ),
							&format,
							&brush_kana
						);

						word_width = max( word_width, stringsizef.Width );
						word_height += stringsizef.Height;
					}

					int info_width = 0;
					int info_height = 0;
					for( int i = 0; i < e->info.size(); i++ ) {
						SizeF stringsizef;
						graphics.MeasureString(
							e->info[i].c_str(),
							e->info[i].size(),
							&font_hover_info,
							sizef,
							&format,
							&stringsizef
						);

						graphics.DrawString(
							e->info[i].c_str(),
							e->info[i].size(),
							&font_hover_info,
							PointF( hover_bw+hover_word_bw+word_width+hover_word_spacer, hover_bh+info_height ),
							&format,
							&brush_info
						);

						// Draw the dots next to the text:
						graphics.FillRectangle(
							&SolidBrush( color_result_info ),
							(INT)(hover_bw+hover_word_bw+word_width+hover_word_spacer - 10),
							(INT)(hover_bh+info_height + stringsizef.Height/2-3),
							(INT)4,(INT)4
						);

						info_width = max( info_width, stringsizef.Width );
						info_height += stringsizef.Height;
					}

					int meaning_width = 0;
					int meaning_height = 0;
					for( i = 0; i < e->meaning.size(); i++ ) {
						SizeF stringsizef;
						graphics.MeasureString(
							e->meaning[i].c_str(),
							e->meaning[i].size(),
							&font_hover_meaning,
							sizef,
							&format,
							&stringsizef
						);

						graphics.DrawString(
							e->meaning[i].c_str(),
							e->meaning[i].size(),
							&font_hover_meaning,
							PointF( hover_bw+hover_word_bw+word_width+hover_word_spacer, hover_bh+info_height+hover_info_spacer+meaning_height ),
							&format,
							&brush_meaning
						);

						graphics.FillRectangle(
							&SolidBrush( Color(60,60,60) ),
							(INT)(hover_bw+hover_word_bw+word_width+hover_word_spacer - 10),
							(INT)(hover_bh+info_height+hover_info_spacer+meaning_height + stringsizef.Height/2-3),
							(INT)6,(INT)6
						);


						meaning_width = max( meaning_width, stringsizef.Width );
						meaning_height += stringsizef.Height;
					}

					int width = hover_bw + word_width + hover_word_spacer + meaning_width + hover_bw;
					int height = hover_bh + max(word_height,meaning_height) + hover_bh;



		   EndPaint(hWnd, &ps);
			return(0); // An application should return 0 if it processes WM_PAINT.
		}//*/
		case WM_ERASEBKGND: {
			// An application should return 0 if it did NOT erase the backgound.
			// Here, we're faking that we did, so...
			return(TRUE);
		}//*/
		case WM_LBUTTONDOWN: {
			return(0); // An application should return 0 if it processes WM_LBUTTONDOWN.
		}
		case WM_LBUTTONDBLCLK: {
			// wParam :: what virtual keys are down.
			// lParam :: LONG( x, y ).
			return(0); // An application should return 0 if it processes WM_LBUTTONDBLCLK.
		}
		case WM_RBUTTONDOWN: {
			return(0); // An application should return 0 if it processes WM_RBUTTONDOWN.
		}
		case WM_MOUSEMOVE: {
			int mx = LOWORD(lParam), my = HIWORD(lParam);
			return(0); // An application should return 0 if it processes WM_MOUSEMOVE.
		}
		case WM_MOUSEHOVER: {
			return(0);
		}
		case WM_KEYDOWN: {
			return(0);
		}
	}
	return( DefWindowProc(hWnd, message, wParam, lParam) );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateResult_Hover_Window( HWND hwndParent, int x,int y, int w,int h ) {
	WNDCLASS wndClass; 
	   //wndClass.style          = CS_SAVEBITS; //CS_HREDRAW | CS_VREDRAW;
		wndClass.style          = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wndClass.lpfnWndProc    = WndProc_Result_Hover_Window;
	   wndClass.cbClsExtra     = 0;
		wndClass.cbWndExtra     = 0;
	   wndClass.hInstance      = g_hinst;
		wndClass.hIcon          = NULL;//LoadIcon(NULL, IDI_APPLICATION);
	   wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
		wndClass.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
	   wndClass.lpszMenuName   = NULL;
		wndClass.lpszClassName  = TEXT("Result_Hover_Window");
   
   RegisterClass( &wndClass );
   
   HWND hWnd = CreateWindowEx(
		0,
      TEXT("Result_Hover_Window"),   // window class name
      TEXT("(Result_Hover_Window)"),  // window caption
      WS_POPUP, // window style
      x,y, // (x,y)
      w,h, // (w,h)
      hwndParent,                     // parent window handle
      NULL,                     // window menu handle
      g_hinst,                // program instance handle
      NULL                    // creation parameters
	);
	  
   //ShowWindow(hWnd, SW_SHOW);
	return(hWnd);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
