// Result_List.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef RESULT_LIST_H
#define RESULT_LIST_H
///////////////////////////////////////////////////////////
/* NOTE:
	*  Okay, when it says 'index' of a header, it does not
	mean the actual index; it means the INITIAL index of
	the thing.
	   In other words, if you drag element 0 to the last
	position, and then you click it, you *still* clicked
	element zero; it hasn't moved in memory; just on the
	screen.
*/
///////////////////////////////////////////////////////////
/* 2002.12.23
		Each item's lparam is the index of the item's information
	in an array of header-item information.
*/
enum {
	HDR_RESULT_WORD = 0,
	HDR_RESULT_KANA,
	HDR_RESULT_INFO,
	HDR_RESULT_MEANING,
	HDR_RESULT_WORD_L,
	HDR_RESULT_KANA_L,
	HDR_RESULT_MAX
};
struct Header_Item_Information {
	int hwnd; // This is the window that it's in.
	int percent; // The percentage of the window that the button takes up.
	int position; // The position of the item in its header.
	HDITEM header_item; // This is the item.
};

Header_Item_Information result_header_items[HDR_RESULT_MAX];
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void LoadResultHeaderInfo() {
	registry.CD(".\\Results\\HeaderItems");
	for( int i = 0; i < HDR_RESULT_MAX; i++ ) {
		char path[10];
			sprintf(path,"%i",i );
		registry.CD(path);

		result_header_items[i].hwnd = registry.GetINT("Header");
		result_header_items[i].percent = registry.GetINT("Percentage");
		result_header_items[i].position = registry.GetINT("Position");

		Log(1,L"result_header_items[%i]\n",i );
		Log(1,L"   hwnd: %i\n", result_header_items[i].hwnd );
		Log(1,L"   percent: %i\n",result_header_items[i].percent );
		Log(1,L"   position: %i\n",result_header_items[i].position );

		registry.CD("..");
	}
}
///////////////////////////////////////////////////////////
void SaveResultHeaderInfo() {
	registry.CD(".\\Results\\HeaderItems");
	for( int i = 0; i < HDR_RESULT_MAX; i++ ) {
		char path[10];
			sprintf(path,"%i",i );
		registry.CD(path);

		registry.SetINT("Header",result_header_items[i].hwnd);
		registry.SetINT("Percentage",result_header_items[i].percent);
		registry.SetINT("Position",result_header_items[i].position);

		registry.CD("..");
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
/* This creates the two header controls. */
void CreateResultHeaders( HWND hwndParent ) { 
	// Get the client area of the parent window.
	// (We're going to use it to resize the header bar).
	RECT rc;
		GetClientRect( hwndParent, &rc );

	///////////////////////////
	///   THE TOP CONTROL   ///
	///////////////////////////
	// Create an empty header control.
	HWND hwndList = CreateWindowEx(
		0,
		WC_HEADER, (LPCTSTR)NULL,
		WS_VISIBLE | WS_CHILD | HDS_BUTTONS | HDS_DRAGDROP,// | HDS_FULLDRAG, //| HDS_FILTERBAR, // | HDS_HORZ, //| WS_BORDER,
      0,0, 100,16,
		hwndParent,
		(HMENU)WID_RESULT_LIST1,
		g_hinst, 
      (LPVOID)NULL
	);
	if( !hwndList ) {
		Log(L"ERROR: CreateResult_Headers(): Could not create window (1).\n");
		MessageBox(NULL,L"ERROR: CreateResult_Headers(): Could not create window (1).",L"ERROR",MB_OK );
		exit(-1);
	}
	SendMessage( hwndList,WM_SETFONT, (WPARAM)hfont_msgothic12, (LPARAM)true );
	
	// Assign the header control:
	hwnd_resultlist[0] = hwndList;
 

	//////////////////////////////
	///   THE BOTTOM CONTROL   ///
	//////////////////////////////
	// Create another empty header control.
	hwndList = CreateWindowEx(
		0,
		WC_HEADER, (LPCTSTR)NULL,
		WS_VISIBLE | WS_CHILD | HDS_BUTTONS | HDS_DRAGDROP,// | HDS_FULLDRAG, //| HDS_FILTERBAR, // | HDS_HORZ, //| WS_BORDER,
      0,0, 100,16,
		hwndParent,
		(HMENU)WID_RESULT_LIST2,
		g_hinst, 
      (LPVOID)NULL
	);
	if( !hwndList ) {
		Log(L"ERROR: CreateResult_Headers(): Could not create window (2).\n");
		MessageBox(NULL,L"ERROR: CreateResult_Headers(): Could not create window (2).",L"ERROR",MB_OK );
		exit(-1);
	}
	SendMessage( hwndList,WM_SETFONT, (WPARAM)hfont_msgothic12, (LPARAM)true );
	
	// Assign the header control:
	hwnd_resultlist[1] = hwndList;


	for( int i = 0; i < HDR_RESULT_MAX; i++ ) {
		int w = 10;
		HDITEM *hdi = &result_header_items[i].header_item;
		ZeroMemory( hdi, sizeof(*hdi) );
			hdi->mask = HDI_TEXT | HDI_FORMAT | HDI_WIDTH | HDI_LPARAM;
			hdi->fmt = HDF_LEFT | HDF_STRING;
			switch( i ) {
				case 0: {	hdi->pszText = L"Word";  break;	}
				case 1: {	hdi->pszText = L"Kana";  break;	}
				case 2: {	hdi->pszText = L"Info";  break;	}
				case 3: {	hdi->pszText = L"Meaning";  break;	}
				case 4: {	hdi->pszText = L"W";  break;	}
				case 5: {	hdi->pszText = L"K";  break;	}
				default: {  hdi->pszText = L"Error";  break;	}
			}
			hdi->cxy = w;
			hdi->lParam = i;
			hdi->cchTextMax = sizeof(hdi->pszText)/sizeof(hdi->pszText[0]);
	}
} 
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
// This scales the header control to a certain width and height.
void Header_ScaleItems( HWND hwndList, int w,int h ) {
	/*{
		Log(L"Percent Going In: ");
		int numitems = Header_GetItemCount(hwndList);
		for( int i = 0; i < numitems; i++ ) {
			HDITEM hdi;
			ZeroMemory( &hdi, sizeof(hdi) );
				hdi.mask = HDI_WIDTH|HDI_LPARAM;
			Header_GetItem( hwndList, i, &hdi );

			int percentage = result_header_items[hdi.lParam].percent;
			Log(L"| %2i%% |",percentage );
		}
		Log(L"\n");
	}//*/



	{
		////////////////////////////////////////////////////////
		///   MAKE SURE THAT THE PERCENTAGES ADD UP TO 100   ///
		////////////////////////////////////////////////////////

		// Get the total percentage:
		int numitems = Header_GetItemCount(hwndList);
		int percentage_so_far[2] = { 0, 0 };
		for( int i = 0; i < HDR_RESULT_MAX; i++ ) {
			Header_Item_Information *info = &result_header_items[i];
			int percentage = info->percent;
			if( info->hwnd != -1 ) {
				percentage_so_far[info->hwnd] += percentage;
			}
		}

		// 'scale' is how much we need to multiply each percentage to get them to add up right.
		double scale[2] = { 100.0/double(percentage_so_far[0]), 100.0/double(percentage_so_far[1]) };

		// Go though and multiply each percentage by 'scale'.
		percentage_so_far[0] = 0; percentage_so_far[1] = 0;
		for( i = 0; i < HDR_RESULT_MAX; i++ ) {
			Header_Item_Information *info = &result_header_items[i];
			if( info->hwnd != -1 ) {
				info->percent = (int)( double(info->percent)*scale[info->hwnd] );
				if( info->percent < 1 ) {  info->percent = 1;  }
				percentage_so_far[info->hwnd] += info->percent;
			}
		}

		// Now, we've multiplied all of the percentages by 'scale'.
		// However, they still might be messed up.


		for( int p = 0; p < 2; p++ ) {
			if( percentage_so_far[p] != 100 ) {
				//Log(L"Percentage_so_far[%i]: %i\n",p,percentage_so_far[p] );
				int diff = percentage_so_far[p] - 100;
				for( i = 0; i < HDR_RESULT_MAX; i++ ) {
					Header_Item_Information *info = &result_header_items[i];
					if( info->hwnd == p && info->percent-diff > 0 ) {
						info->percent -= diff;
						// And, we're done with messing with this.
						diff = 0;
						break;
					}
				}
			}
		}
	}











	SetWindowPos( hwndList, 0, 0,0, w,h, SWP_NOZORDER|SWP_NOMOVE );

	int numitems = Header_GetItemCount(hwndList);
	int wsofar = 0;
	for( int i = 0; i < numitems; i++ ) {
		HDITEM hdi;
		ZeroMemory( &hdi, sizeof(hdi) );
			hdi.mask = HDI_WIDTH|HDI_LPARAM;
		Header_GetItem( hwndList, i, &hdi );

			double percentage = double(result_header_items[hdi.lParam].percent)/100.0;
			hdi.cxy = (int)(percentage*double(w));
			wsofar += hdi.cxy;

			// If it's the last item, fix things up:
			if( i == numitems-1 ) {
				if( wsofar < w ) {
					hdi.cxy += w-wsofar;
				} else if( wsofar > w ) {
					hdi.cxy -= wsofar-w;
				}
			}

		Header_SetItem( hwndList, i, &hdi );
	}
	SetWindowPos( hwndList, 0, 0,0, 0,0, SWP_NOZORDER|SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW );


	/*{
		Log(L"Percent Going Out:");
		int numitems = Header_GetItemCount(hwndList);
		for( int i = 0; i < numitems; i++ ) {
			HDITEM hdi;
			ZeroMemory( &hdi, sizeof(hdi) );
				hdi.mask = HDI_WIDTH|HDI_LPARAM;
			Header_GetItem( hwndList, i, &hdi );

			int percentage = result_header_items[hdi.lParam].percent;
			Log(L"| %2i%% |",percentage );
		}
		Log(L"\n");
	}//*/
}
///////////////////////////////////////////////////////////
/*		This completely sets up the header bars based on the
   information about their items.
	   This can be used to:
			Add/Delete items.
			Resize items
*/
void SetResultHeaders( HWND hwndParent ) {
	// Get the client area of the parent window.
	// (We're going to use it to resize the header bars).
	RECT rc;
		GetClientRect( hwndParent, &rc );

	// Go through each control.
	// Make sure that it's in the right spot.
	for( int index = 0; index < HDR_RESULT_MAX; index++ ) {
		/*Log(1,L"YAR: result_header_items[%i]\n",index );
		Log(1,L"   hwnd: %s\n", result_header_items[index].hwnd==NULL?L"NULL":L"not null");
		Log(1,L"   percent: %i\n",result_header_items[index].percent );
		Log(1,L"   position: %i\n",result_header_items[index].position );*/
		Header_Item_Information *info = &result_header_items[index];

		// If the item isn't in a list, make sure that it ISN'T.
		if( info->hwnd == -1 ) {
			Header_RemoveItemFromHeader( hwnd_resultlist[0], index );
			Header_RemoveItemFromHeader( hwnd_resultlist[1], index );
			continue;
		}

		// Did we find the item in this header bar?
		bool found = Header_IsItemWithLParamInHeader( hwnd_resultlist[info->hwnd], index );
		
		if( found ) {
			Log(1,L"Found the item (%i) in its header.\n",index );
		} else {
			Log(1,L"Could NOT find the item (%i) in its header.\n",index );
		}

		// If we didn't find it where it's supposed to be,
		// see if it's in another header bar.
		//    If it is, remove it.
		// Add it to the header bar.
		if( !found ) {
			// We're going to check the other header bar.
			int hwnd = (info->hwnd==0)?1:0;
			// Remove it if it's in there:
			Header_RemoveItemFromHeader( hwnd_resultlist[hwnd], index );
			
			// Okay, we KNOW that that item is in NO HEADER BAR right now.

			// Add it to the one that it belongs to.

			Log(1,L"info->hwnd: %i\n",info->hwnd );

			Header_InsertItem( hwnd_resultlist[info->hwnd], Header_GetItemCount(hwnd_resultlist[info->hwnd]), &info->header_item );
			Log(1,L"Item %i inserted\n",index );
			Log(1,L"There are %i items in there\n", Header_GetItemCount(hwnd_resultlist[info->hwnd]) );
		}

		// Okay, we KNOW that the item is in the header bar that it SHOULD BE in.
	}


	// Here, we should set the order:
	int *order[2];
		order[0] = new int[ Header_GetItemCount( hwnd_resultlist[0] ) ];
		order[1] = new int[ Header_GetItemCount( hwnd_resultlist[1] ) ];
	for( index = 0; index < HDR_RESULT_MAX; index++ ) {
		Header_Item_Information *info = &result_header_items[index];
		if( info->hwnd == -1 ) {  continue;  }

		order[info->hwnd][info->position] = Header_GetIndexOfItemWithLParamOf( hwnd_resultlist[info->hwnd], index );
	}

	if( debug_level > 0 ) {
		for( int j = 0; j < 2; j++ ) {
			Log(L"BAR (desired): %i :: ",j );
			for( int k = 0; k < Header_GetItemCount( hwnd_resultlist[j] ); k++ ) {
				Log(L"| %i (%i) |", order[j][k], Header_GetLParamOfIndex( hwnd_resultlist[j], order[j][k] ) );
			}
			Log(L"\n");
		}
	}

	BOOL b = Header_SetOrderArray( hwnd_resultlist[0], Header_GetItemCount( hwnd_resultlist[0] ), order[0] );
	if( !b ) {
		Log(L"ERROR: Could not set the first ordering\n");
	}
	b = Header_SetOrderArray( hwnd_resultlist[1], Header_GetItemCount( hwnd_resultlist[1] ), order[1] );
	if( !b ) {
		Log(L"ERROR: Could not set the second ordering\n");
	}



	// Fix up the sizes of the items by percentage.
	RECT rcList;
		GetClientRect( hwnd_resultlist[0], &rcList );
	Header_ScaleItems( hwnd_resultlist[0], rc.right,rcList.bottom );
		GetClientRect( hwnd_resultlist[1], &rcList );
	Header_ScaleItems( hwnd_resultlist[1], rc.right,rcList.bottom );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
