// Search_Toolbar.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef SEARCH_TOOLBAR_H
#define SEARCH_TOOLBAR_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_Lang( HWND hwndParent ) { 
	const int numbuttons = 3;
	TBBUTTON tbb[numbuttons];
		// button 1 properties
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_LANG_JP;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;

		// button 2 properties
		tbb[1].iBitmap = 1;
		tbb[1].idCommand = ID_LANG_EN;
		tbb[1].fsState = TBSTATE_ENABLED;
		tbb[1].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;
		tbb[1].dwData = 0;
		tbb[1].iString = NULL;

		// seperator properties
		tbb[2].iBitmap = 2;
		tbb[2].idCommand = ID_LANG_X;
		tbb[2].fsState = TBSTATE_ENABLED;
		tbb[2].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;
		tbb[2].dwData = 0;
		tbb[2].iString = NULL;

	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_LANG,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_LANG,
	   tbb,
   	numbuttons,
	   16,15,
	   16*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_SearchType( HWND hwndParent ) { 
	const int numbuttons = 4;
	TBBUTTON tbb[numbuttons];
		// button 1 properties
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_SEARCH_START;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;

		// button 2 properties
		tbb[1].iBitmap = 1;
		tbb[1].idCommand = ID_SEARCH_MIDDLE;
		tbb[1].fsState = TBSTATE_ENABLED;
		tbb[1].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;
		tbb[1].dwData = 0;
		tbb[1].iString = NULL;

		// seperator properties
		tbb[2].iBitmap = 2;
		tbb[2].idCommand = ID_SEARCH_END;
		tbb[2].fsState = TBSTATE_ENABLED;
		tbb[2].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;
		tbb[2].dwData = 0;
		tbb[2].iString = NULL;

		// button 4 properties
		tbb[3].iBitmap = 3;
		tbb[3].idCommand = ID_SEARCH_WHOLE;
		tbb[3].fsState = TBSTATE_ENABLED;//|TBSTATE_CHECKED;
		tbb[3].fsStyle = TBSTYLE_BUTTON|BTNS_CHECKGROUP;
		tbb[3].dwData = 0;
		tbb[3].iString = NULL;

	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_SEARCHTYPE,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_SEARCHTYPE,
	   tbb,
   	numbuttons,
	   16,15,
	   16*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_Strings( HWND hwndParent ) {
	const int numbuttons = 3;
	TBBUTTON tbb[numbuttons];
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_MATCHSUBSTRINGS;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = BTNS_CHECK;// | BTNS_AUTOSIZE;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;

		tbb[1].iBitmap = 1;   // Array of picture to show
		tbb[1].idCommand = ID_FORCEWORDSEARCH;
		tbb[1].fsState = TBSTATE_ENABLED;  // button status
		tbb[1].fsStyle = BTNS_CHECK;// | BTNS_AUTOSIZE;   // button style
		tbb[1].dwData = 0;
		tbb[1].iString = NULL;

		tbb[2].iBitmap = 2;   // Array of picture to show
		tbb[2].idCommand = ID_FUZZY;
		tbb[2].fsState = TBSTATE_ENABLED;  // button status
		tbb[2].fsStyle = BTNS_CHECK;// | BTNS_AUTOSIZE;   // button style
		tbb[2].dwData = 0;
		tbb[2].iString = NULL;
	
	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_STRINGS,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_STRINGS,
	   tbb,
   	numbuttons,
	   16,15,
	   16*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_Conversion( HWND hwndParent ) {
	const int numbuttons = 4;
	TBBUTTON tbb[numbuttons];
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_SEARCH_CONVERSION_ROMAJI;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = BTNS_CHECK;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;

		tbb[1].iBitmap = 1;   // Array of picture to show
		tbb[1].idCommand = ID_SEARCH_CONVERSION_KANA;
		tbb[1].fsState = TBSTATE_ENABLED;  // button status
		tbb[1].fsStyle = BTNS_CHECK;   // button style
		tbb[1].dwData = 0;
		tbb[1].iString = NULL;

		tbb[2].iBitmap = 0;   // Array of picture to show
		tbb[2].idCommand = 0;
		tbb[2].fsState = TBSTATE_ENABLED;  // button status
		tbb[2].fsStyle = BTNS_SEP;   // button style
		tbb[2].dwData = 0;
		tbb[2].iString = NULL;

		tbb[3].iBitmap = 2;   // Array of picture to show
		tbb[3].idCommand = ID_SEARCH_CONVERSION_SHOW;
		tbb[3].fsState = TBSTATE_ENABLED;  // button status
		tbb[3].fsStyle = BTNS_CHECK;   // button style
		tbb[3].dwData = 0;
		tbb[3].iString = NULL;

	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_SEARCHCONVERSION,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_SEARCHCONVERSION,
	   tbb,
   	numbuttons,
	   16,15,
	   16*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_EncodeGo( HWND hwndParent ) {
	const int numbuttons = 1;
	TBBUTTON tbb[numbuttons];
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_ENCODE_PASTE;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = BTNS_BUTTON;// | BTNS_AUTOSIZE;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;
	
	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_SEARCHGO,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_ENCODEGO,
	   tbb,
   	numbuttons,
	   16,15,
	   16*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateSearch_Toolbar_SearchGo( HWND hwndParent ) {
	const int numbuttons = 1;
	TBBUTTON tbb[numbuttons];
		tbb[0].iBitmap = 0;   // Array of picture to show
		tbb[0].idCommand = ID_SEARCH_GO;
		tbb[0].fsState = TBSTATE_ENABLED;  // button status
		tbb[0].fsStyle = BTNS_BUTTON;// | BTNS_AUTOSIZE;   // button style
		tbb[0].dwData = 0;
		tbb[0].iString = NULL;
	
	HWND tb_hwindow = CreateToolbarEx(
	   hwndParent,
   	WS_VISIBLE | TBSTYLE_TOOLTIPS | TBSTYLE_FLAT | 
		CCS_NOPARENTALIGN | CCS_NOMOVEY | CCS_NODIVIDER | CCS_NORESIZE,
	   IDR_TOOLBAR_SEARCHGO,
   	numbuttons,
	   g_hinst,
   	IDR_TOOLBAR_SEARCHGO,
	   tbb,
   	numbuttons,
	   45,15,
	   45*numbuttons,15,
	   sizeof(TBBUTTON)
	);

	return(tb_hwindow);
};
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#include <commctrl.h>
///////////////////////////////////////////////////////////
// Handle the tool tip messages.
// Basically, this tells Windows the text for the tool tip.
// Now, it should only ask for one at a time, so we should
// only need one buffer.
char tt_buffer[2048];
void HandleTooltips( LPARAM lParam ) {
	if( lParam == NULL ) {
		Log(L"ERROR: HandleTooltips(): lParam == NULL\n");
		return;
	}

	NMTTDISPINFO *info = (NMTTDISPINFO*)lParam;
		NMHDR *hdr = &info->hdr;

	switch( hdr->code ) { 
		//case TTN_NEEDTEXT:
		case TTN_NEEDTEXTW:
		case TTN_NEEDTEXTA: {
			// Modes:
			//		0: UNICODE
			//		1: not unicode.
			int tt_mode = 0;
			if( hdr->code == TTN_NEEDTEXTA ) {
				tt_mode = 1;
			}

			info->lpszText = NULL;
			info->szText[0] = '\0';
			info->szText[1] = '\0';
			info->hinst = NULL;

			// If we have the handle of the tooltip:
			if( info->uFlags&TTF_IDISHWND ) {
				Log(L"ERROR: JLookUp doesn't do tooltips with a handle.\n");
				return;
			}

			// Otherwise, this is the ID:
			UINT idButton = hdr->idFrom;

 
			///////////////////////////
			///   ASSIGN THE TEXT   ///
			///////////////////////////
			// This is the temporary buffer for the text:
         Uint16 str_tt[1024];
         switch (idButton) {
				case ID_SEARCH_START: {					wsprintf(str_tt, L"Text appears at the beginning");  break;  }
				case ID_SEARCH_MIDDLE: {				wsprintf(str_tt, L"Text appears in the middle");  break;  }
				case ID_SEARCH_END: {					wsprintf(str_tt, L"Text appears at the end");  break;  }
				case ID_SEARCH_WHOLE: {					wsprintf(str_tt, L"Search for exact text");  break;  }
				case ID_MATCHSUBSTRINGS: {				wsprintf(str_tt, L"Match multiple substrings" );  break;  }
				case ID_FORCEWORDSEARCH: {				wsprintf(str_tt, L"(checked)\nOnly search in the words (~kanji) for the text\n(unchecked)\nLet JLookUp choose how to search." );  break;  }
				case ID_FUZZY: {							wsprintf(str_tt, L"If checked, this causes JLookUp to attempt to reverse-conjugate whatever word is being searched for." );  break;  }
				case ID_SEARCH_CONVERSION_ROMAJI: {	wsprintf(str_tt, L"Convert ROMAji to kana");  break;  }
				case ID_SEARCH_CONVERSION_KANA: {	wsprintf(str_tt, L"Kana insensitive search");  break;  }
				case ID_SEARCH_CONVERSION_SHOW: {	wsprintf(str_tt, L"Show the converted string");  break;  }
				case ID_ENCODE_PASTE: {					wsprintf(str_tt, L"<-- (format)\nConvert whatever's on the clipboard\ninto (format) format.\nUNICODE is the default.");  break;  }
				case ID_SEARCH_GO: {						wsprintf(str_tt, L"Search");  break;  }
				case ID_LANG_JP: {						wsprintf(str_tt, L"Force JLookUp to search for this text as Japanese");  break;  }
				case ID_LANG_EN: {						wsprintf(str_tt, L"Force JLookUp to search for this text as English");  break;  }
				case ID_LANG_X: {							wsprintf(str_tt, L"Let JLookUp choose how to search");  break;  }
				default: {									wsprintf(str_tt, L"(NULL)" );  }
         } // switch( idbutton )

			// Format things correctly for Unicode and non-unicode applications.
			if( tt_mode == 0 ) {
				// If it's Unicode, we just copy the text to the buffer, and assign
				// the pointer to the buffer.
				wcscpy( (Uint16*)tt_buffer, str_tt );
				info->lpszText = (LPTSTR)tt_buffer;
			} else {
				// If it's not Unicode, we need to copy the text to the buffer
				// (but convert it to ASCII first), and then assign the pointer
				// to the buffer.
				sprintf( (char*)tt_buffer,"%s",ToString(str_tt).c_str() );
				info->lpszText = (LPTSTR)tt_buffer;
			}
			break;
		} // case TTN_NEEDTEXT
   } // switch(code)
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
