// Threads.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef THREADS_H
#define THREADS_H
///////////////////////////////////////////////////////////
#include "Radical.h"

#include "Search_Dict.h"

#include "Window_Thread.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void InitThreads() {
	// This is useless for now.
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
bool thread_searching = false;
bool thread_terminate_searching = false;
int thread_search_exitcode = 0;
//wstring thread_search_text = L"";

enum { TS_NORMAL, TS_EDICT_ONLY };
struct THREAD_SEARCH {
	wstring *search_text;
	int mode;
};
///////////////////////////////////////////////////////////
DWORD WINAPI Thread_Search( LPVOID lpParam ) {
	if( lpParam == NULL ) {
		Log(L"Thread_Search(): ERROR: lpParam == NULL\n");
		return(0);
	}

	THREAD_SEARCH *ts = (THREAD_SEARCH*)lpParam;
	//wstring searchtext = *(ts->search_text);
	// Maybe the above method is bad?
	wstring searchtext = ts->search_text->c_str();

	Log(1,L"Thread_Search().\n");
	Log(1,L"   THREAD_SEARCH\n");
	Log(1,L"      SEARCH_TEXT: %s\n",ts->search_text->c_str() );
	Log(1,L"      MODE: %i\n",ts->mode );
	Log(1,L"   searchtext: %s\n",searchtext.c_str() );

	int search_status = 0;

	if( ts->mode == TS_NORMAL ) {
		Log(1,L"   M O D E  ::  TS_NORMAL.\n");

		// Do the search:
		edict_results.clear();
		Log(1,L"   edict_results cleared.\n");

		search_status = Edict_SearchFor( searchtext );
			// Note: this sorts the results, too.
		Log(1,L"   searchtext searched for.\n");

		if( search_matchsubstrings == 1 ) {
			if( searchtext.find(WC_QUES) != (wstring::size_type)(-1) || searchtext.find(WC_STAR) != (wstring::size_type)(-1) ) {
				// Don't do the substring matching.
			} else {
				// Do the substring matching:
				// First, force word-searching if there's kanji in there.
				// (the results will be better this way):
				int old_search_forcewordsearch = search_forcewordsearch;
				if( !IsKana( searchtext ) ) {
					search_forcewordsearch = 1;
				}
				// Start with substring sizes of one and work up:
				for( int i = 1; i < searchtext.size(); i++ ) {
					// Try the string in different spots:
					for( int p = 0; p <= searchtext.size()-i; p++ ) {
						wstring substr = searchtext.substr( p,i );

						search_status = Edict_SearchFor( substr );
					}
				}
				// Restore the old value:
				search_forcewordsearch = old_search_forcewordsearch;
			}
		}
		// (all edict results are also sorted).


		// Kanji:
		kanjidic_results.clear();
		SetStatusBarText(L"Searching for Kanji...");
		// Go through the edict results looking for kanji:
		for( int i = 0; i < edict_results.size(); i++ ) {
			KanjiWindow_SearchForKanjiIn( edict_results[i].word );
		}

	} else if( ts->mode == TS_EDICT_ONLY ) {
		Log(1,L"   M O D E  ::  TS_EDICT_ONLY.\n");
		// Do the search:
		edict_results.clear();
		search_status = Edict_SearchFor( searchtext );
			// Note: this sorts the results, too.
	}


	//thread_search_text = searchtext;
	*(ts->search_text) = searchtext;


	thread_searching = false;
	thread_terminate_searching = false;
	thread_search_exitcode = search_status;

	Log(1,L"Thead all done.\n");
	return(0);
}

HANDLE Load_Thread_Search( THREAD_SEARCH *ts ) {
	if( thread_searching ) {
		MessageBox(NULL,L"There is still a search/dictionary-load going on.  Load_Thread_Search() will not open a new one.",L"Error",MB_OK );
		Log(L"ERROR: Load_Thread_Search(): thread_searching is TRUE\n");
		return(NULL);
	}
	thread_searching = true;
	thread_terminate_searching = false;
	thread_search_exitcode = 0;

	CreateThreadWindow(L"Searching...");
	if( !hwnd_searching ) {
		Log(L"ERROR: Load_Thread_Search(): Failed to create the thread window\n");
	}
	
	// Force it to draw the window:
	UpdateWindow( hwnd_searching );

	DWORD id;
	HANDLE handle = CreateThread(
		NULL,
		0,
		Thread_Search,
		(LPVOID)ts,
		0,
		&id
	);
	return( handle );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
DWORD WINAPI Thread_EDICT_Index_Load( LPVOID lpParam ) {
   Dictionary_EDICT *dictionary = (Dictionary_EDICT*)lpParam;


	// Set the status bar text:
	Uint16 str[1024];
		swprintf(str,L"Loading EDICT: %S...",dictionary->filename.c_str() );
	SetStatusBarText(str);

	EDICT_Index_Load( dictionary );

	thread_searching = false;
	return(0);
}

HANDLE Load_Thread_EDICT_Index_Load( Dictionary_EDICT *dictionary ) {
	if( thread_searching ) {
		MessageBox(NULL,L"There is still a search/dictionary-load going on.  Load_Thread_EDICT_Index_Load() will not open a new one.",L"Error",MB_OK );
		Log(L"ERROR: Load_Thread_Index_Load(): thread_searching is TRUE\n");
		return(NULL);
	}

	thread_searching = true;

	CreateThreadWindow(L"Loading Dictionary...");
	if( !hwnd_searching ) {
		Log(L"ERROR: Load_Thread_EDICT_Index_Load(): Failed to create the thread window\n");
	}

	// Force it to draw the window:
	UpdateWindow( hwnd_searching );

	DWORD id;
	HANDLE handle = CreateThread(
		NULL,
		0,
		Thread_EDICT_Index_Load,
		(LPVOID)dictionary,
		0,
		&id
	);
	return(handle);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
DWORD WINAPI Thread_LoadAllEDICTS( LPVOID lpParam ) {
	///////////////////////////////////////
	///   Load the markers for EDICT:   ///
	///////////////////////////////////////
	SetStatusBarText(L"Loading Markers...");
		LoadMarkers();

	//////////////////////////
	///   Load KANJIDIC:   ///
	//////////////////////////
	SetStatusBarText(L"Loading KANJIDIC...");
		KANJIDIC_Index_Load();

	////////////////////////
	///   Load RADDAT:   ///
	////////////////////////
	SetStatusBarText(L"Loading RADKFILE...");
		LoadRadicalInfo( ToWString( registry.GetSTRING(".\\Dictionaries\\RADKFILE\\Path") ) );


	////////////////////////////
	///   Load the EDICTs:   ///
	////////////////////////////
	SetStatusBarText(L"Pre-loading EDICTs...");
	registry.CD( "Dictionaries\\EDICT" );
	for( int d = 0; d < registry.GetINT("Number"); d++ ) {
		// Change to the key of the dictionary:
		char cnumber[10];
			itoa( d,cnumber,10 );
		registry.CD( cnumber );


		Dictionary_EDICT *edict_current = new Dictionary_EDICT;
			// Set its path:
			edict_current->filename = registry.GetSTRING("Path");
			// Set its name:
			edict_current->displayname = registry.GetSTRING("Name");
			// Set its encoding:
			edict_current->encoding = registry.GetSTRING("Encoding");
			// Set whether to search with it:
			edict_current->on = registry.GetBOOL("On");
			// Set its size to zero:
			edict_current->index_entries_size = 0;

		// Add it to the dictionaries:
		edict_dictionaries.push_back( edict_current );

		// Go back to EDICT.
		registry.CD("..");
	}
	SetStatusBarText(L"Pre-loading EDICTs... OKAY");


	/////////////////////////////////////////////
	///   ACTUALLY LOAD THE EDICT (INDEXES)   ///
	/////////////////////////////////////////////
	for( d = 0; d < edict_dictionaries.size(); d++ ) {
		// Set the status bar text:
		Uint16 str[1024];
			swprintf(str,L"Loading EDICT: %S...",edict_dictionaries[d]->filename.c_str() );
		SetStatusBarText(str);

		// Load it:
		EDICT_Index_Load( edict_dictionaries[d] );

			swprintf(str,L"EDICT (%S) Loaded.",edict_dictionaries[d]->filename.c_str() );
		SetStatusBarText(str);
	}

	// (Everything's loaded).
	SetStatusBarText(L"Okay!!");


	thread_searching = false;
	return(0);
}

HANDLE Load_Thread_LoadAllEDICTS() {
	if( thread_searching ) {
		MessageBox(NULL,L"There is still a search/dictionary-load going on.  Load_Thread_LoadAllEDICTS() will not open a new one.",L"Error",MB_OK );
		Log(L"ERROR: Load_Thread_LoadAllEDICTS(): thread_searching is TRUE\n");
		return(NULL);
	}

	thread_searching = true;

	//CreateThreadWindow(L"Loading Dictionaries...",false);
	CreateThreadWindow(L"Loading...",false);
	if( !hwnd_searching ) {
		Log(L"ERROR: Load_Thread_LoadAllEDICTS(): Failed to create the thread window\n");
	}

	// Force it to draw the window:
	UpdateWindow( hwnd_searching );

	DWORD id;
	HANDLE handle = CreateThread(
		NULL,
		0,
		Thread_LoadAllEDICTS,
		(LPVOID)NULL,
		0,
		&id
	);
	return(handle);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
