// Update.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef UPDATE_H
#define UPDATE_H
///////////////////////////////////////////////////////////
#include "Http.h"

#include "CRC.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
bool IsUpdateFile( char *file ) {
	FILE *f = fopen( file, "rt" );
	if( f ) {
		char buff[256];
		fgets( buff,256-1,f );
		if( strcmp(buff,"# updates.v2.txt\n") == 0 ) {  return(true);  }
		else {  return(false); }
	} else {
		return(false);
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
struct SERVER {
	char *server, *path, *files;
};
SERVER servers[] = {
	{ "aumaan.home.comcast.net", "JLookUp/updates/updates.v2.txt", "JLookUp/updates/files" },
	{ "jlookup.aumaan.no-ip.org", "updates/updates.v2.txt", "updates/files" }
};
int servers_size = 2;
///////////////////////////////////////////////////////////
vector<string> get_files;
string get_id;
///////////////////////////////////////////////////////////
#include "Window_Update.h"
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
enum {
	NEWS_ID,
	NEWS_TYPE,
	NEWS_NEWS,
	NEWS_DATE,
	NEWS_APPLIESTO,
	NEWS_INFO,
	NEWS_FILE,
	NEWS_MAX
};
struct NEWS {
	string data[NEWS_MAX];
	vector<string> files;
	vector<string> info;
	string appliesto;
	string id;
	string type;
};
///////////////////////////////////////////////////////////
/* A version string can be ONE OF THE FOLLOWING:
	x		== x
	-x		<  x
	x-		<= x
	+x		>  x
	x+		>= x
*/
bool VersionIsIn( string version, string test ) {
	// Equality test:
	if( version == test ) {
		return(true);
	}

	///   M I N U S   ///
	int minus = test.find('-');
	// Less than: '-1.0.6' (applies to '1.0.3', '1.0.5f'...)
	if( minus == 0 ) {
		test = test.substr(1,-1);
		if( version < test ) {
			// Keep:
			return(true);
		}
	}
	// Less than or Equal to: '1.0.6-' (applies to ...'1.0.3'...'1.0.6')
	else if( minus == test.size()-1 ) {
		test = test.substr( 0, test.size()-1 );
		if( version <= test ) {
			// Keep:
			return(true);
		}
	}

	///   P L U S   ///
	int plus = test.find('+');
	// Greater than: '+1.0.6' (applies to '1.0.6a', '1.0.8'...)
	if( plus == 0 ) {
		test = test.substr(1,-1);
		if( version > test ) {
			// Keep:
			return(true);
		}
	}
	// Greater than or Equal to: '1.0.6+' (applies to '1.0.6'...'1.0.8'...)
	else if( plus == test.size()-1 ) {
		test = test.substr( 0, test.size()-1 );
		if( version >= test ) {
			// Keep:
			return(true);
		}
	}

	// Nope, the versions don't match.
	return(false);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void Update() {
	char *updatefile = "updates.v2.txt";
	// Get the window up & running:
	hwnd_update = CreateWindow_Update( hwnd_mainwindow, CW_USEDEFAULT,CW_USEDEFAULT, 600,600 );
		SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"..." );
	//RedrawWindow( hwnd_update, NULL,NULL, RDW_INVALIDATE );

	////////////////////////////////////
	///   CHECK FOR UPDATES ONLINE   ///
	////////////////////////////////////
	// Put some text up:
	SendMessage(hwnd_update_edit,WM_SETTEXT,0,(LPARAM)L"Press ESCAPE to stop checking for updates..." );
	// Thread time:
	HANDLE hthread = Load_Thread_CheckForUpdates( updatefile );
	enum {  UPDATE_ABORT, UPDATE_DONE, UPDATE_QUIT  };
	int wtf = -1;
	MSG msg;
	while( true ) {
		if( !thread_updating ) {  wtf = UPDATE_DONE;  break;  }
		// Check to see if we have an ESCAPE key message.
		PeekMessage( &msg, NULL, 0,0, PM_REMOVE );
		TranslateMessage(&msg);
		if( msg.message == WM_KEYDOWN && msg.wParam == VK_ESCAPE ) {  wtf = UPDATE_ABORT;  break;  }
		if( msg.message == WM_QUIT ) {  wtf = UPDATE_QUIT;  break;  }
		DispatchMessage(&msg);

		Sleep( 10L );
	}
	if( wtf != UPDATE_DONE ) {
		////////////////////////////////
		///   UPDATE CHECK ABORTED   ///
		////////////////////////////////
		TerminateThread( hthread, 0L );
		CloseHandle(hthread);
		thread_updating = false;

		// Kill the window:
		DestroyWindow( hwnd_update );

		if( wtf == UPDATE_QUIT ) {
			// Close the program:
			SendMessage(hwnd_mainwindow,WM_QUIT,0,0);
		}
		// All done here:
		return;
	} else {
		CloseHandle(hthread);
	}

	bool okaytoupdate = thread_checkforupdates_exitcode;


	if( okaytoupdate ) {
		SendMessage(hwnd_update_edit,WM_SETTEXT,0,(LPARAM)L"" );
		SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"Found updates" );
	} else {
		SendMessage(hwnd_update_edit,WM_SETTEXT,0,(LPARAM)L"No updates found" );
		SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"No updates found" );
	}




	// Set up the CRC table:
	crcgen();

	// Clear the globals:
	get_files.clear();
	get_id = "";

	// See what updates we already have:
	vector<string> updates;
	FILE *fup = fopen("Updates.jlf","rt");
	if( fup ) {
		while( !feof(fup) ) {
			char line[100];
			fgets( line,100-1,fup );
			if( feof(fup) ) {  break;  }
			if( line[strlen(line)-1] == '\n' ) {  line[strlen(line)-1] = '\0';  }
			updates.push_back(line);
		}
		fclose(fup);
	}

	// Process the updates:
	FILE *fdl = fopen(updatefile,"rt");
	if( fdl ) {
		vector<NEWS> vector_news;
		bool first = true;
		NEWS news;
		int mode = -1;
		while( !feof(fdl) ) {
			char line[10000];
			fgets( line, 10000-1, fdl );
			if( line[0] == '#' ) {  continue;  }
			//if( strcmp(line,"\n")==0 && mode != -1 ) {  news.data[mode] += "\\par ";  }
			if( strcmp(line,"NEWS\n") == 0 ) {
			///   NEWS   ///
				mode = NEWS_NEWS;

				if( !first ) {
					if( news.files.size() == 0 ) {
						news.data[NEWS_FILE] = "(There are no files for this update)\\line";
					}
					vector_news.push_back(news);
					NEWS news2;
					news = news2;
				} else {
					first = false;
				}
			} else if( strcmp(line,"DATE\n") == 0 ) {
			///   DATE   ///
				mode = NEWS_DATE;
			} else if( strcmp(line,"ID\n") == 0 ) {
				mode = NEWS_ID;
			} else if( strcmp(line,"TYPE\n") == 0 ) {
				mode = NEWS_TYPE;
			} else if( strcmp(line,"APPLIES TO\n") == 0 ) {
			///   APPLIES TO   ///
				mode = NEWS_APPLIESTO;
			} else if( strcmp(line,"INFO\n") == 0 ) {
			///   INFO   ///
				mode = NEWS_INFO;
			} else if( strcmp(line,"FILE\n") == 0 ) {
			///   FILE   ///
				mode = NEWS_FILE;
			} else {
				if( mode != -1 ) {
					if( line[strlen(line)-1] == '\n' ) {  line[strlen(line)-1] = '\0';  }
					news.data[mode] += line;
					news.data[mode] += "\\line ";

					if( mode == NEWS_INFO ) {
						news.info.push_back(line);
					} else if( mode == NEWS_FILE ) {
						news.files.push_back(line);
					} else if( mode == NEWS_APPLIESTO ) {
						news.appliesto = line;
					} else if( mode == NEWS_ID ) {
						news.id = line;
					} else if( mode == NEWS_TYPE ) {
						news.type = line;
					}
				}
			}
		}
		fclose( fdl );
		if( news.files.size() == 0 ) {
			news.data[NEWS_FILE] = "(There are no files for this update)\\line";
		}
		vector_news.push_back(news);


		// Keep only the items that pertain to this version:
		for( int n = 0; n < vector_news.size(); n++ ) {
			// See if we already have it;
			bool alreadyhave = false;
			for( int u = 0; u < updates.size(); u++ ) {
				if( updates[u] == vector_news[n].id ) {
					alreadyhave = true;
					break;
				}
			}

			if( !alreadyhave && wcscmp(version_type,ToWString(vector_news[n].type).c_str()) == 0 || vector_news[n].type == "All") {
			// NOTE: go through this only if the versions match.

				// See if the news applies to this version:
				string version = ToString(version_info);
					version = version.substr( 0, version.find(' ') );
				// Explicitly: '1.0.6a' (applies to '1.0.6a')
				if( !alreadyhave && (vector_news[n].appliesto == "All" || vector_news[n].appliesto == version) ) {
					// Keep:
					continue;
				} else if( !alreadyhave ) {
					int pos = vector_news[n].appliesto.find('/');
					if( pos == -1 ) {
						if( VersionIsIn(version,vector_news[n].appliesto) ) {
							continue;
						}
					} else {
					// Range: '1.0.6+/-1.0.6f' (applies to '1.0.6', '1.0.6a'...'1.0.6e')
						string lower = vector_news[n].appliesto.substr(0,pos);
						string higher = vector_news[n].appliesto.substr(pos+1,-1);
						if( VersionIsIn(version,lower) && VersionIsIn(version,higher) ) {
							continue;
						}
					}
				}
			}
			
			// Remove:
			vector_news.erase( vector_news.begin()+n );
			n--;
		}

		// Only download the oldest one with files:
		for( n = 0; n < vector_news.size(); n++ ) {
			int current = vector_news.size()-1-n;
			if( vector_news[current].files.size() > 0 ) {
				get_id = vector_news[current].id;
				for( int f = 0; f < vector_news[current].files.size(); f++ ) {
					get_files.push_back( vector_news[current].files[f] );
				}
				break;
			}
		}


		SETTEXTEX st;
			st.flags = ST_KEEPUNDO|ST_SELECTION;
			st.codepage = 1200; // 1200 == unicode.


		for( int f = 0; f < get_files.size(); f++ ) {
			Uint16 str[1024];
				swprintf(str,L"%S\n",get_files[f].c_str() );
			SendMessage( hwnd_update_files,EM_SETTEXTEX, (WPARAM)&st, (LPARAM)str );
		}



		for( n = 0; n < vector_news.size(); n++ ) {
			char buffer[10000];
			sprintf(buffer,"\
{\\rtf\
{\\colortbl;\\red128\\green128\\blue128;}\
{\\i\\fs26 %s}\
{\\b\\fs30 %s}\
{\\fs20\\cf1\\i This applies to version: %s}\
{\\li360\\fs20 %s}\\par\
{\\b\\fs22 Files}\\par\
{\\li360\\fs20\\cf1 %s}\
}",
				vector_news[n].data[NEWS_DATE].c_str(),
				vector_news[n].data[NEWS_NEWS].c_str(),
				vector_news[n].data[NEWS_APPLIESTO].c_str(),
				vector_news[n].data[NEWS_INFO].c_str(),
				vector_news[n].data[NEWS_FILE].c_str()
			);
			SendMessage( hwnd_update_edit,EM_SETTEXTEX, (WPARAM)&st, (LPARAM)buffer );

			if( n != vector_news.size()-1 ) {  SendMessage( hwnd_update_edit,EM_SETTEXTEX, (WPARAM)&st, (LPARAM)"{\\rtf{\\colortbl;\\red64\\green64\\blue255;}{\\par\\par\\cf1 =======================================\\par\\par\\par}" );  }
		}


	} else {
	// The file was not opened.
		SendMessage(hwnd_update_status,WM_SETTEXT,0,(LPARAM)L"There was an error when opening the file." );
	}











	
	//MSG msg;
	int result = 0;
	while( true ) {
		result = GetMessage( &msg, NULL, 0,0 );
		if( result > 0 ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else if( result == 0 ) {
			break;
		} else {
			MessageBox(NULL,L"Error",L"Negative number",MB_OK );
		}
		// The window NULLs itself on closing:
		if( hwnd_update == NULL ) {
			break;
		}
	}
	RedrawWindow( hwnd_mainwindow, NULL,NULL, RDW_INVALIDATE );

	if( result == 0 ) {
		SendMessage( hwnd_mainwindow,WM_QUIT,0,0 );
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
