// Window_Thread.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef WINDOW_THREAD_H
#define WINDOW_THREAD_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND hwnd_searching = NULL;
wstring searching_text = L"";
bool show_escape = true;
LRESULT CALLBACK WndProc_Searching_Window( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
   switch( message ) {
		/*case WM_CREATE: {
			return(0);
		}
		case WM_SIZE: {
			return( 0 );
		}//*/
		case WM_PAINT: {
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hWnd, &ps);

/*{
   Graphics graphics(hdc);
   // Set up the string.
   WCHAR string[] = L"Measure Text";
   Font font(L"Arial", 16);
   SizeF layoutSize(100, 50);
   StringFormat format;
   format.SetAlignment(StringAlignmentFar);
   SizeF stringSize;
   // Measure the string.
   int result = graphics.MeasureString(string, 12, &font, layoutSize, &format, &stringSize);
   // Draw a rectangle that represents the size of the string.
   result = graphics.DrawRectangle(&Pen(Color(255, 0, 0, 0)), Rect(0, 0, stringSize.Width, stringSize.Height));
}//*/

			   Graphics graphics(hdc);

				RECT rcClient;
					GetClientRect( hWnd, &rcClient );

				// Fill in the window with the border color:
				SolidBrush brush_outside( Color(128,128,128) );
				RectF rcFill;
					rcFill.X = rcClient.left;
					rcFill.Y = rcClient.top;
					rcFill.Width = rcClient.right;
					rcFill.Height = rcClient.bottom;
				graphics.FillRectangle( &brush_outside, rcFill );


				// Fill in the inside with the inside color:
				SolidBrush brush_inside( Color(196,196,196) );
					rcFill.X += 2; rcFill.Y += 2;
					rcFill.Width -= 4; rcFill.Height -= 4;
				graphics.FillRectangle( &brush_inside, rcFill );


				// Get the fonts set up:
				//FontFamily ff_arial( L"Arial" );
				FontFamily ff_arial( ToWString(registry.GetSTRING(".\\Misc\\Font\\Font")).c_str() );
					Font font_text( &ff_arial,20 );
					Font font_text2( &ff_arial,14 );


				// This is the text color:
				SolidBrush brush_text( Color(0,0,0) );

				// This is the format:
				StringFormat format(0);
					format.SetTrimming( StringTrimmingNone );

				// This is the space that we're working in:
				SizeF sizef( rcFill.Width, rcFill.Height );
				// This is the size of the string:
				SizeF stringsizef( 0,0 );


				// Measure the string:
				int result = graphics.MeasureString( searching_text.c_str(), searching_text.size(), &font_text,
					sizef,
					&format,
					&stringsizef
				);


				// Center the text and draw it:
				// (we use rcClient to center it).
				int x = rcClient.right/2-stringsizef.Width/2;
				int y = rcClient.bottom/2-stringsizef.Height/2;
#ifndef NOTEXT
				result = graphics.DrawString( searching_text.c_str(), searching_text.size(), &font_text,
					PointF( x,y ),
					&format,
					&brush_text
				);
#endif

				// Next line:
				y += stringsizef.Height;

				// If we're showing: (Press ESC to stop), ...
				if( show_escape ) {
					// Make the text and measure it:
					wstring text = L"(Press ESC to stop)";
					result = graphics.MeasureString( text.c_str(), text.size(), &font_text2,
						sizef,
						&format,
						&stringsizef
					);

					x = rcClient.right/2-stringsizef.Width/2;

					// Draw it:
#ifndef NOTEXT
					result = graphics.DrawString( text.c_str(), text.size(), &font_text2,
						PointF( x, y ),
						&format,
						&brush_text
					);
#endif
				}

/*
#ifdef UBERDEBUG
			EndPaint( hWnd, &ps );
			return(0);
#endif
//*/
			// ALL DONE:
			EndPaint( hWnd, &ps );
			return(0); // An application should return 0 if it processes WM_PAINT.
		}
		case WM_ERASEBKGND: {
			// An application should return 0 if it did NOT erase the backgound.
			// Here, we're faking that we did, so...
			return(TRUE);
		}
   }
   return( DefWindowProc(hWnd, message, wParam, lParam) );
} // WndProc
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void CreateThreadWindow( wstring text, bool escape=true ) {
	if( hwnd_searching != NULL ) {
		Log(L"WARNING: CreateThreadWindow(): hwnd_searching is NOT null!\n");
		if( DestroyWindow( hwnd_searching ) ) {
			hwnd_searching = NULL;
		} else {
			Log(L"ERROR: CreateThreadWindow(): couldn't destroy it!\n");
			return;
		}
	}

	static bool firsttime = true;
	if( firsttime ) {
		WNDCLASS wndClass;
			wndClass.style          = CS_HREDRAW | CS_VREDRAW;
			wndClass.lpfnWndProc    = WndProc_Searching_Window;
		   wndClass.cbClsExtra     = 0;
			wndClass.cbWndExtra     = 0;
		   wndClass.hInstance      = g_hinst;
			wndClass.hIcon          = NULL;
			wndClass.hCursor        = NULL;//LoadCursor(NULL, IDC_ARROW);
			wndClass.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH); //GetSysColorBrush(COLOR_MENU);
		   wndClass.lpszMenuName   = NULL;
			wndClass.lpszClassName  = TEXT("Searching");
   
		if( RegisterClass(&wndClass) == 0 ) {
			MessageBox(NULL,L"Error registering window class.",L"Error",MB_OK );
			exit(-1);
		}
		firsttime = false;
	}

	show_escape = escape;
	searching_text = text;

	HWND hwndold = GetCapture();

	int w = 300, h = 150;   
   HWND hwnd = CreateWindowEx(
		0,//WS_EX_TOPMOST,
      TEXT("Searching"), // window class name
		L"WindowTitle", // Window title
		WS_POPUP, // window style
      0,0,
		w,h,
      hwnd_mainwindow, // parent window handle
      NULL, // window menu handle
      g_hinst, // program instance handle
      NULL // creation parameters
	);
	if( hwnd == NULL ) {
		MessageBox(NULL,L"hwnd_searching not made!",L"Error",MB_OK );
	}

	SetCapture(hwndold);

	RECT rcClient;
		GetClientRect(hwnd_mainwindow,&rcClient );
	RECT rcWindow;
		GetWindowRect(hwnd_mainwindow,&rcWindow );
	int x = rcWindow.left + rcClient.right/2-w/2;
	int y = rcWindow.top + rcClient.bottom/2-h/2;
	//x = 0; y = 0;
	SetWindowPos(hwnd,NULL,x,y,0,0,SWP_NOACTIVATE|SWP_SHOWWINDOW|SWP_NOZORDER|SWP_NOSIZE);

	//Log(L"hwnd_searching: %i,%i, %i,%i\n",x,y,w,h );

	hwnd_searching = hwnd;
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////